options(shiny.maxRequestSize = 250*1024^2)

source("www/R/CableDisTurbinas.R", local = T)
source("www/R/curvaCorreccion.R", local = T)
source("www/R/curvaPotencia.R", local = T)
source("www/R/Energia_Mensual_conPer.R", local = T)
source("www/R/Energia_Mensual_sinPer.R", local = T)
source("www/R/Energia_MensualVarAlt_conPer.R", local = T)
source("www/R/Energia_MensualVarAlt_sinPer.R", local = T)
source("www/R/leypot.R", local = T)
source("www/R/mapaParque.R", local = T)
source("www/R/mapaTorre.R", local = T)
source("www/R/mapaTrazado.R", local = T)
source("www/R/MCP.R", local = T)
source("www/R/rhositio.R", local = T)
source("www/R/serie.R", local = T)
source("www/R/solo_pos.R", local = T)
source("www/R/torre.R", local = T)
source("www/R/velocidadEstela.R", local = T)
source("www/R/velocidadEstelaVarAlt.R", local = T)
source("www/R/velocidadEstela_GranPar.R", local = T)
source("www/R/velocidadEstelaVarAlt_GranPar.R", local = T)
source("www/R/rosaViento.R", local = T)

`%then%` <- shiny:::`%OR%`

server <- function(input, output) {
  
  ## Navigation
  observeEvent(input$MostrarParque, {
    shinyjs::toggle(id = "ParqueDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$MostrarTrazado, {
    shinyjs::toggle(id = "TrazadoDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$MostrarTorres, {
    shinyjs::toggle(id = "TorresMap", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$ZoomParque, {
    shinyjs::toggle(id = "ZParqueDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$ZoomTrazado, {
    shinyjs::toggle(id = "ZTrazadoDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$ZoomTorres, {
    shinyjs::toggle(id = "ZTorreDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$TablaParque, {
    shinyjs::toggle(id = "ParqueTabDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$MostrarCurvas, {
    shinyjs::toggle(id = "CurvaDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$TablaCurva, {
    shinyjs::toggle(id = "CurvaTabDiv", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Ingresar_Info, {
    observe({
      input_btn <- paste0("TablasViento_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("TablasViento_", "", i))
          shinyjs::toggle(id = paste0("VientoTabDiv_", j), anim = T,animType = "slide",time=0.4)
        })
      })
    })
    observe({
      input_btn <- paste0("RGUI_VD_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("RGUI_VD_", "", i))
          shinyjs::toggle(id = paste0("RGUIVD_", j), anim = T,animType = "slide",time=0.4)
        })
      })
    })
    observe({
      input_btn <- paste0("RGUI_TPH_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("RGUI_TPH_", "", i))
          shinyjs::toggle(id = paste0("RGUITPH_", j), anim = T,animType = "slide",time=0.4)
        })
      })
    })
    observe({
      input_btn <- paste0("DosA_Torre_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("DosA_Torre_", "", i))
          shinyjs::toggle(id = paste0("DosATorre_", j), anim = T,animType = "slide",time=0.4)
        })
      })
    })
    observe({
      input_btn <- paste0("TresA_Torre_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("TresA_Torre_", "", i))
          shinyjs::toggle(id = paste0("TresATorre_", j), anim = T,animType = "slide",time=0.4)
        })
      })
    })
    shinyjs::toggle(id = "IngresarInfo", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_SEC, {
    shinyjs::toggle(id = "RGUISEC", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_Densidad, {
    shinyjs::toggle(id = "RGUIDensidad", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_CurvaCorr, {
    shinyjs::toggle(id = "RGUICurvaCorr", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_Alpha, {
    shinyjs::toggle(id = "RGUIAlpha", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_VelSitioCubo, {
    shinyjs::toggle(id = "RGUIVelSitioCubo", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Subir_Alpha, {
    shinyjs::toggle(id = "SubirAlpha", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_MCP, {
    shinyjs::toggle(id = "RGUIMCP", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Subir_paraEstelas, {
    shinyjs::toggle(id = "SubirparaEstelas", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Velocidad_Extrapolada, {
    shinyjs::toggle(id = "VelocidadExtrapolada", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_ESTELA, {
    shinyjs::toggle(id = "RGUIESTELA", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Subir_Final, {
    shinyjs::toggle(id = "SubirFinal", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$RGUI_EneFinal, {
    shinyjs::toggle(id = "RGUIEneFinal", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Uno_Cubo, {
    shinyjs::toggle(id = "UnoCubo", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Varios_Cubo, {
    shinyjs::toggle(id = "VariosCubo", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Perdidas_Electricas, {
    shinyjs::toggle(id = "PerdidasElectricas", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$Grandes_Parques, {
    shinyjs::toggle(id = "GrandesParques", anim = T,animType = "slide",time=0.4)
  })
  observeEvent(input$TablaSecundaria, {
    shinyjs::toggle(id = "VientoTabSec", anim = T,animType = "slide",time=0.4)
  })
  
  ## Lectura de .csv del Parque Eólico
  parqueEolico <- reactive({
    inFile <- input$Parque_eolico
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    return(read.csv(inFile$datapath))
  })
  
  ## Lectura de .csv de Alturas de Cubo
  VariasAlturas <- reactive({
    inFile <- input$Varias_Alt_Cubo
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    return(read.csv(inFile$datapath))
  })
  
  trazadoElectrico <- reactive({
    inFile <- input$Cableado
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    return(read.csv(inFile$datapath))
  })
  
  ## Dibuja Mapa en el ActionButton
  observeEvent(input$MostrarParque, {
    output$parqueEolico.plot <- renderPlot({
      csvParque <- parqueEolico()
      shiny::validate(
        need(csvParque != "", "Por favor, suba un archivo con la información del parque eólico.")
      )
      mapaParque(csvParque, alejar = FALSE)
    })
  })
  observeEvent(input$ZoomParque, {
    output$ZparqueEolico.plot <- renderPlot({
      csvParque <- parqueEolico()
      shiny::validate(
        need(csvParque != "", "Por favor, suba un archivo con la información del parque eólico.")
      )
      mapaParque(csvParque, alejar = TRUE)
    })
  })
  
  observeEvent(input$MostrarTrazado, {
    output$trazadoElectrico.plot <- renderPlot({
      parque <- parqueEolico()
      shiny::validate(
        need(parque != "", "Por favor, suba un archivo con la información del parque eólico.")
      )
      PCC <- c(as.numeric(input$LongPCC),as.numeric(input$LatPCC))
      shiny::validate(
        need(PCC != "", "Para mostrar el mapa de cableado y realizar el cálculo de pérdidas debe ingresar el trazado eléctrico y 
         las coordenadas del Punto de Conexión Común.")
      )
      shiny::validate(
        need(trazadoElectrico() != "", "Para mostrar el mapa de cableado y realizar el cálculo de pérdidas debe ingresar el trazado eléctrico y 
             las coordenadas del Punto de Conexión Común.")
        )
      mapaTrazado(parque, PCC, trazadoElectrico(), alejar = FALSE)
    })
  })
  observeEvent(input$ZoomTrazado, {
    output$ZtrazadoElectrico.plot <- renderPlot({
      parque <- parqueEolico()
      shiny::validate(
        need(parque != "", "Por favor seleccione una serie de datos.")
      )
      PCC <- c(as.numeric(input$LongPCC),as.numeric(input$LatPCC))
      mapaTrazado(parque, PCC, trazadoElectrico(), alejar = TRUE)
    })
  })
  
  pos_torres <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      shiny::validate(
        need(input[[paste0("LongTorre_", i)]] != "Valor con punto decimal", "Por favor, ingrese la coordenada de longitud 
             en grados decimales correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(input[[paste0("LatTorre_", i)]] != "Valor con punto decimal", "Por favor, ingrese la coordenada de latitud 
             en grados decimales correspondiente a cada torre meteorológica.")
      )
      ##Se retorna el objeto "torre" que representa una torre meteorologica.
      ##Contiene informacion de las posiciones de las torres.
      return(solo_pos(pos=c(as.numeric(input[[paste0("LongTorre_", i)]]), 
                         as.numeric(input[[paste0("LatTorre_", i)]])), desc=paste0("Torre ", i)))
    })
  })
  
  observeEvent(input$MostrarTorres, {
    output$torresMap.plot <- renderPlot({
      mapaTorre(pos_torres(), alejar = FALSE)
    })
  })
  
  observeEvent(input$ZoomTorres, {
    output$ZtorresMap.plot <- renderPlot({
      mapaTorre(pos_torres(), alejar = TRUE)
    })
  })
  
  ## Imprime la tabla del parque eólico
  observeEvent(input$TablaParque, { 
    output$parqueEolico.out <- DT::renderDataTable({
      csvParque <- parqueEolico()
      shiny::validate(
        need(csvParque != "", "Por favor seleccione una serie de datos.")
      )
      csvParque
    })
  })
  
  ## Lectura de .csv de las curvas de Potencia y Empuje
  curva_pot_emp <- reactive({
    inFile <- input$Curva_Potencia_Empuje
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    return(read.csv(inFile$datapath))
  })
  
  curvas1.plot <- reactive({
    csvCurva <- curva_pot_emp()
    shiny::validate(
      need(csvCurva != "", "Por favor seleccione una serie de datos.")
    )
    shiny::validate(
      need(input$Vel_Salida != "Valor con punto decimal", "Por favor, ingrese la velocidad de salida de la turbina eólica.")
    )
    shiny::validate(
      need(input$Pot_nominal != "Valor con punto decimal", "Por favor, ingrese la potencia nominal de la turbina eólica.")
    )
    ggplot(csvCurva, aes(csvCurva[[1]], csvCurva[[2]])) + 
      geom_line(color='red',size=1) +
      coord_cartesian(xlim=c(0,as.numeric(input$Vel_Salida)), ylim=c(0,as.numeric(input$Pot_nominal))) +
      scale_x_continuous(expand = c(0,0.1)) +
      scale_y_continuous(breaks = seq(0, 10000, by = 200), expand = c(0.01,0.01)) +
      labs(title ="Curva de Potencia del Fabricante", x = "Velocidad [m/s]", y = "Potencia [kW]") +
      theme_bw() + theme(text = element_text(size=20))
  })
  
  curvas2.plot <- reactive({
    csvCurva <- curva_pot_emp()
    shiny::validate(
      need(csvCurva != "", "Por favor seleccione una serie de datos.")
    )
    shiny::validate(
      need(input$Vel_Salida != "Valor con punto decimal", "Por favor, ingrese la velocidad de salida de la turbina eólica.")
    )
    ggplot(csvCurva, aes(csvCurva[[1]], csvCurva[[3]])) + 
      geom_line(color='green',size=1) +
      coord_cartesian(xlim=c(0,as.numeric(input$Vel_Salida)), ylim=c(0,1)) +
      scale_x_continuous(expand = c(0,0.1)) +
      scale_y_continuous(breaks = seq(0, 1, by = 0.2), expand = c(0.0075,0.0075)) +
      labs(title ="Curva de Coeficiente de Empuje del Fabricante", x = "Velocidad [m/s]", y = "Coeficiente de Empuje [-]") +
      theme_bw() + theme(text = element_text(size=20))
  })
  
  observeEvent(input$MostrarCurvas, {
    ## Dibuja Curvas de Potencia y Empuje en el ActionButton
    output$curvas.plot <- renderPlot({
      ptlist <- list(curvas1.plot(),curvas2.plot())
      grid.arrange(grobs=ptlist,ncol=1,nrow=2)
    })
  })
  
  ## Imprime la tabla de la curva de potencia y empuje
  observeEvent(input$TablaCurva, {
    output$curvas.out <- DT::renderDataTable({
      csvCurva <- curva_pot_emp()
      shiny::validate(
        need(csvCurva != "", "Por favor seleccione una serie de datos.")
      )
      csvCurva
    })
  })
  
  ## Lectura de .csv de las mediciones de velocidad y dirección en sitio
  datos_velsitio <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      inFile <- input[[paste0("datosvel_sitio_", i)]]
      if (is.null(inFile)){return(NULL)}
      shiny::validate(
        need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
      )
      return(read.csv(inFile$datapath))
    })
  })
  
  ## Lectura de .csv de las mediciones de temperatura, humedad y presión en sitio
  datos_sitio_met <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      inFile <- input[[paste0("datosclima_sitio_", i)]]
      if (is.null(inFile)){return(NULL)}
      shiny::validate(
        need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
      )
      return(read.csv(inFile$datapath))
    })
  })
  
  observe({
    if (input$NumTorres!="") {
      input_btn <- paste0("TablasViento_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("TablasViento_", "", i))
          
          output[[paste0("datos_sitio.out_", j)]] <- DT::renderDataTable({
            csvCurva <- datos_velsitio()[[j]]
            shiny::validate(
              need(csvCurva != "", "Por favor seleccione una serie de datos.")
            )
            csvCurva
          })
          
          output[[paste0("datos_met.out_", j)]] <- DT::renderDataTable({
            csvCurva <- datos_sitio_met()[[j]]
            shiny::validate(
              need(csvCurva != "", "Por favor seleccione una serie de datos.")
            )
            csvCurva
          })
        })
      })
      }
  })
  
  observeEvent(input$Ingresar_Info, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
      output[[paste0("torreingresada_", i)]] <- renderUI({
        div(br(), tags$div(id="POCSBO2", h4(paste0("TORRE ", i)),
                           tags$div(
                             HTML("Ingrese las coordenadas geográficas de la torre en grados decimales:")
                           ),
                           splitLayout(
                             textInput(inputId=paste0("LongTorre_", i), label = "Longitud",
                                       "Valor con punto decimal"),
                             textInput(inputId=paste0("LatTorre_", i), label = "Latitud",
                                       "Valor con punto decimal")
                           ),
                           textInput(inputId=paste0("RadRep_", i), label = "Ingrese el radio de representatividad de la torre [km]:",
                                     "Valor con punto decimal"),
                           fileInput(inputId=paste0("datosvel_sitio_", i), 
                                     label = "Cargue el archivo .csv con las mediciones en sitio de velocidad y dirección del viento
                                     para por lo menos un año de medición.",multiple = FALSE, accept = c(".csv"), buttonLabel = "Explorar..."),
                           fileInput(inputId=paste0("datosclima_sitio_", i), 
                                     label = "Cargue el archivo .csv con las mediciones en sitio de temperatura, presión y humedad relativa
                                     para por lo menos un año de medición.",multiple = FALSE, accept = c(".csv"), buttonLabel = "Explorar..."),
                           tags$div(
                             HTML("Especifique si la torre tiene dos o tres alturas de medición de velocidad:")
                           ),
                           p(
                             actionButton(paste0("DosA_Torre_", i), label = "DOS Alturas de Medición")
                           ),
                           shinyjs::hidden(
                             div(id = paste0("DosATorre_", i), 
                                 textInput(inputId=paste0("AltDVel_1_", i), label = "Altura del Nivel Inferior de Velocidad [m]",
                                           "Valor con punto decimal"),
                                 textInput(inputId=paste0("AltDVel_2_", i), label = "Altura del Nivel Superior de Velocidad [m]",
                                           "Valor con punto decimal")
                             )
                           ),
                           p(
                             actionButton(paste0("TresA_Torre_", i), label = "TRES Alturas de Medición")
                           ),
                           shinyjs::hidden(
                             div(id = paste0("TresATorre_", i), 
                                 textInput(inputId=paste0("AltTVel_1_", i), label = "Altura del Nivel Inferior de Velocidad [m]",
                                           "Valor con punto decimal"),
                                 textInput(inputId=paste0("AltTVel_2_", i), label = "Altura del Nivel Medio de Velocidad [m]",
                                           "Valor con punto decimal"),
                                 textInput(inputId=paste0("AltTVel_3_", i), label = "Altura del Nivel Superior de Velocidad [m]",
                                           "Valor con punto decimal")
                             )
                           ),
                           textInput(inputId=paste0("AltDir_1_", i), label = "Altura del Nivel Inferior de Dirección [m]",
                                     "Valor con punto decimal"),
                           textInput(inputId=paste0("AltDir_2_", i), label = "Altura del Nivel Superior de Dirección [m]",
                                     "Valor con punto decimal"),
                           textInput(inputId=paste0("AltTemp_", i), label = "Altura del Nivel de Medición de Temperatura [m]",
                                     "Valor con punto decimal"),
                           tags$div(
                             HTML(paste(tags$span(style="color:red", "RECUERDE: "), "El aplicativo exige como mínimo la siguiente información:", 
                                        tags$span(style="color:red", " 1. "), "Longitud y Latitud de la Torre.", 
                                        tags$span(style="color:red", " 2. "), "Radio de Representatividad.", 
                                        tags$span(style="color:red", " 3. "), "Datos de medición de velocidad y dirección", tags$span(style="color:red", " y/o "), 
                                        " de temperatura, presión y humedad relativa.", tags$span(style="color:red", " 4. "), 
                                        "Las alturas de medición de cada variable, según sea el caso. No incluir esta información le impedirá
                                        visualizar y usar las variables ingresadas en pasos de cálculo posteriores.", sep = ""))
                            )
                           ))
      })
    })
    
    output$UI_V_TORRES <- renderUI({
      misTabs <- lapply(1:as.numeric(input$NumTorres), function(i) {
        tabPanel(paste0("TORRE ", i),
                 fluidRow(
                   wellPanel(
                     p(
                       actionButton(paste0("RGUI_VD_",i), label = "Velocidad y Dirección Medidas en Sitio"),
                       br()
                     ),

                     shinyjs::hidden(
                       div(id = paste0("RGUIVD_",i), align="center",
                           uiOutput(paste0("UIVelocidadDireccion_", i))
                       )
                     )
                   ),
                   wellPanel(
                     p(
                       actionButton(paste0("RGUI_TPH_", i), label = "Temperatura, Presión y Humedad en Sitio"),
                       br()
                     ),
                     shinyjs::hidden(
                       div(id = paste0("RGUITPH_", i), h4("Temperatura, Presión y Humedad en Sitio"),
                           plotOutput(paste0("meteo.plot_", i), width = "100%", height = "1800px")
                       )
                     )
                   ),
                   wellPanel(
                     p(
                       actionButton(paste0("TablasViento_", i),"Visualización de Tablas de Datos en Sitio"),
                       br()
                     ),
                     shinyjs::hidden(
                       div(id = paste0("VientoTabDiv_", i),
                           h4("Tablas de Datos de Mediciones de Velocidad y Dirección en Sitio"), 
                           DT::dataTableOutput(paste0("datos_sitio.out_", i), width = "100%"),
                           h4("Tablas de Datos de Mediciones de Temperatura, Presión y Humedad en Sitio"), 
                           DT::dataTableOutput(paste0("datos_met.out_", i), width = "100%")
                       )
                     )
                   )
                 )
        )
      })
      do.call(tabsetPanel, misTabs)
    })
    
    output$UI_C_TORRES <- renderUI({
        lapply(1:as.numeric(input$NumTorres), function(i) {
          uiOutput(paste0("torreingresada_", i))
        })
    })
  })
  
  ## Se crean las torres con las fechas interpretadas y las series de velocidad y direccion en sitio
  torres_sitio <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      shiny::validate(
        need(input[[paste0("LongTorre_", i)]] != "Valor con punto decimal", "Por favor, ingrese la coordenada de longitud
           en grados decimales correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(input[[paste0("LatTorre_", i)]] != "Valor con punto decimal", "Por favor, ingrese la coordenada de latitud
           en grados decimales correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(input[[paste0("RadRep_", i)]] != "Valor con punto decimal", "Por favor, ingrese el radio de representatividad
           en kilómetros correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(datos_velsitio()[[i]] != "", "Por favor, ingrese los datos de medición de cada torre meteorológica.")
      )
      datos_sitio <- datos_velsitio()[[i]]
      shiny::validate(
        need(length(datos_sitio) > 5, "Los datos ingresados en el .csv no tienen la cantidad mínima de columnas requeridas. 
             Esto es un indicio de que las fechas no están siendo entregadas al aplicativo en el formato correcto.
             Recuerde que las fechas de las mediciones deben ser entregadas en columnas numéricas de año, mes, día, hora y minuto.")
        )
      date_string <- rep("",length(datos_sitio[,1]))
      hora_string <- rep("",length(datos_sitio[,1]))
      fecha_string <- rep("",length(datos_sitio[,1]))
      for (j in 1:length(datos_sitio[,1])) {
        date_string[j] <- paste(datos_sitio[,1][j], datos_sitio[,2][j], datos_sitio[,3][j], sep = "/")
        hora_string[j] <- paste(datos_sitio[,4][j], datos_sitio[,5][j], sep = ":")
        fecha_string[j] <- paste(date_string[j], hora_string[j], sep = " ")
      }
      ##Se reinterpreta la fecha y hora de los datos entregados en forma de un arreglo "string" y se convierten a uno "POSIXlt"
      fechas_sitio <- strptime(fecha_string, "%Y/%m/%d %H:%M", "")
      ##Se crean los objetos "serie" con la altura de medicion y la serie de velocidad y dirección promedio
      if (input[[paste0("AltTVel_3_", i)]]=="Valor con punto decimal") {
        shiny::validate(
          need(input[[paste0("AltDVel_1_", i)]] != "Valor con punto decimal", "Por favor, ingrese la altura de medición
               correspondiente a los datos de cada torre meteorológica.")
          )
        shiny::validate(
          need(input[[paste0("AltDVel_2_", i)]] != "Valor con punto decimal", "Por favor, ingrese la altura de medición
               correspondiente a los datos de cada torre meteorológica.")
          )
        serie1 <- serie(altura=as.numeric(input[[paste0("AltDVel_1_", i)]]), v.prom=datos_sitio[,6], dir.prom=datos_sitio[,8])
        serie2 <- serie(altura=as.numeric(input[[paste0("AltDVel_2_", i)]]), v.prom=datos_sitio[,7], dir.prom=datos_sitio[,9])
        ##Se retorna el objeto "torre" que representa una torre meteorologica.
        ##Contiene informacion de las serie suministradas para las fechas registradas.
        return(torre(marcatemporal = fechas_sitio, serie1, serie2, 
                     pos=c(as.numeric(input[[paste0("LongTorre_", i)]]), as.numeric(input[[paste0("LatTorre_", i)]])),
                     radioRep=as.numeric(input[[paste0("RadRep_", i)]]), desc=paste0("Torre ", i)))
      } else {
        shiny::validate(
          need(input[[paste0("AltTVel_1_", i)]] != "Valor con punto decimal", "Por favor, ingrese la altura de medición
               correspondiente a los datos de cada torre meteorológica.")
          )
        shiny::validate(
          need(input[[paste0("AltTVel_2_", i)]] != "Valor con punto decimal", "Por favor, ingrese la altura de medición
               correspondiente a los datos de cada torre meteorológica.")
          )
        shiny::validate(
          need(input[[paste0("AltTVel_3_", i)]] != "Valor con punto decimal", "Por favor, ingrese la altura de medición
               correspondiente a los datos de cada torre meteorológica.")
          )
        dif1 <- c(abs(as.numeric(input[[paste0("AltTVel_1_", i)]])-as.numeric(input[[paste0("AltDir_1_", i)]])), 
                  abs(as.numeric(input[[paste0("AltTVel_2_", i)]])-as.numeric(input[[paste0("AltDir_1_", i)]])),
                  abs(as.numeric(input[[paste0("AltTVel_3_", i)]])-as.numeric(input[[paste0("AltDir_1_", i)]])))
        dif2 <- c(abs(as.numeric(input[[paste0("AltTVel_1_", i)]])-as.numeric(input[[paste0("AltDir_2_", i)]])), 
                  abs(as.numeric(input[[paste0("AltTVel_2_", i)]])-as.numeric(input[[paste0("AltDir_2_", i)]])),
                  abs(as.numeric(input[[paste0("AltTVel_3_", i)]])-as.numeric(input[[paste0("AltDir_2_", i)]])))
        ind1 <- which.min(dif1)
        ind2 <- which.min(dif2)
        if (ind1==1) {
          serie1 <- serie(altura=as.numeric(input[[paste0("AltTVel_1_", i)]]), v.prom=datos_sitio[,6], dir.prom=datos_sitio[,9])
        } else if (ind1==2) {
          serie2 <- serie(altura=as.numeric(input[[paste0("AltTVel_2_", i)]]), v.prom=datos_sitio[,7], dir.prom=datos_sitio[,9])
        } else serie3 <- serie(altura=as.numeric(input[[paste0("AltTVel_3_", i)]]), v.prom=datos_sitio[,8], dir.prom=datos_sitio[,9])
        
        if (ind2==1) {
          serie1 <- serie(altura=as.numeric(input[[paste0("AltTVel_1_", i)]]), v.prom=datos_sitio[,6], dir.prom=datos_sitio[,10])
        } else if (ind2==2) {
          serie2 <- serie(altura=as.numeric(input[[paste0("AltTVel_2_", i)]]), v.prom=datos_sitio[,7], dir.prom=datos_sitio[,10])
        } else serie3 <- serie(altura=as.numeric(input[[paste0("AltTVel_3_", i)]]), v.prom=datos_sitio[,8], dir.prom=datos_sitio[,10])
        
        if (!exists("serie1")) {
          serie1 <- serie(altura=as.numeric(input[[paste0("AltTVel_1_", i)]]), v.prom=datos_sitio[,6])
        } else if (!exists("serie2")) {
          serie2 <- serie(altura=as.numeric(input[[paste0("AltTVel_2_", i)]]), v.prom=datos_sitio[,7])
        } else serie3 <- serie(altura=as.numeric(input[[paste0("AltTVel_3_", i)]]), v.prom=datos_sitio[,8])
        ##Se retorna el objeto "torre" que representa una torre meteorologica.
        ##Contiene informacion de las serie suministradas para las fechas registradas.
        return(torre(marcatemporal = fechas_sitio, serie1, serie2, serie3, 
                     pos=c(as.numeric(input[[paste0("LongTorre_", i)]]), as.numeric(input[[paste0("LatTorre_", i)]])),
                     radioRep=as.numeric(input[[paste0("RadRep_", i)]]), desc=paste0("Torre ", i)))
      }
    })
  })
  
  ##Se calcula el Coeficiente de Cortante en el Sitio
  alpha_sitio <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      torre_ref <- torres_sitio()[[i]]
      if (input$Metodo_Alpha=="Dos Alturas") {
        if (input[[paste0("AltTVel_3_", i)]]=="Valor con punto decimal") {
          useMetodo <- "hellman"
          return(leypot(torre=torre_ref, v.serie=c(1,2), useMetodo)$alpha)
        } else {
          useMetodo <- "hellman"
          return(leypot(torre=torre_ref, v.serie=c(1,3), useMetodo)$alpha)
        }
      } else if (input$Metodo_Alpha=="Tres Alturas") {
        useMetodo <- "potlm"
        return(leypot(torre=torre_ref, v.serie=c(1,2,3), useMetodo)$alpha)
      } else {
        useMetodo <- "justus"
        return(leypot(torre=torre_ref, v.serie=c(1), useMetodo)$alpha)
      }
      
    })
  })
  
  ##Se grafica el día típico y los meses del cortante
  observeEvent(input$RGUI_Alpha, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
      torre_ref <- torres_sitio()[[i]]
      alpha <- alpha_sitio()[[i]]
      r <- as.POSIXct(torre_ref$marcatemporal) #Esta variable se usa para realizar gráficas posteriomente
      hellman <- tibble(date= r, 'Coeficiente Cortante [-]' = alpha)
      
      output[[paste0("dia_alpha.plot_", i)]] <- renderPlot({
        dia_alpha.plot <- plot(timeVariation(hellman,"Coeficiente Cortante [-]",
                                             ylim = c(-0.01,0.31)), subset = "hour")
      })
      output[[paste0("mes_alpha.plot_", i)]] <- renderPlot({
        mes_alpha.plot <- plot(timeVariation(hellman,"Coeficiente Cortante [-]",
                                             ylim = c(-0.01,0.31)), subset = "month")
      })
      
      output[[paste0("descargarAlpha_", i)]] <- downloadHandler(
        filename = function(){
          paste0("CortanteViento-Torre", i, "-", Sys.Date(), ".csv", sep="")
        },
        content = function(file) {
          torre_ref <- torres_sitio()[[i]];
          alpha <- alpha_sitio()[[i]];
          TABLA=data.frame(as.POSIXct(torre_ref$marcatemporal),round(alpha,digits=4));
          DownLoadData <- TABLA;
          colnames(DownLoadData)[1] <- "Fecha";
          colnames(DownLoadData)[2] <- "CoeficienteCortante";
          write.csv(x = DownLoadData, file = file)
        }
      )
    })
    
    output$UIAlphaGrafs <- renderUI({
      lapply(1:as.numeric(input$NumTorres), function(i) {
        div(h4(paste0("Cortante del Viento para la Torre ", i)),
            plotOutput(paste0("dia_alpha.plot_", i), width = "100%", height="600px"),
            plotOutput(paste0("mes_alpha.plot_", i), width = "100%", height="600px")
        )
      })
    })
    
    output$UIAlpha <- renderUI({
      div(
        uiOutput("UIAlphaGrafs"),
        p(
          lapply(1:as.numeric(input$NumTorres), function(i) {
            div(br(),
                downloadButton(paste0("descargarAlpha_", i), paste0("Descargar Serie de Coeficiente de Cortante de Torre ", i))
                )
          })
        ))
    })
  })
  
  observeEvent(input$Subir_Alpha, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
      output[[paste0("cadaSubida1_", i)]] <- renderUI({ 
        fileInput(inputId=paste0("Alpha_Subido_", i), label = paste0("Cargue el archivo .csv que descargó en el botón 
                                                                     ''Descargar Serie de Coeficiente de Cortante de Torre ", i, "'' del Paso 2."),
                  multiple = FALSE, accept = c(".csv"), buttonLabel = "Explorar...")
      })
    })
    
    output$uiSubirAlpha <- renderUI({
      lapply(1:as.numeric(input$NumTorres), function(i) {
        uiOutput(paste0("cadaSubida1_", i))
      })
    })
  })
  
  AlphaSubido <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      inFile <- input[[paste0("Alpha_Subido_", i)]]
      if (is.null(inFile)){return(NULL)}
      shiny::validate(
        need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
      )
      return(read.csv(inFile$datapath))
    })
  })
  
  AlphaSubido2 <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      inFile <- input[[paste0("Alpha_Subido2_", i)]]
      if (is.null(inFile)){return(NULL)}
      shiny::validate(
        need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
      )
      return(read.csv(inFile$datapath))
    })
  })
  
  ##Se separa el cortante de viento por meses y se calcula el día típico por mes
  alpha_meses <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      if (!is.null(input[[paste0("Alpha_Subido_", i)]])) {
        uploadFile <- AlphaSubido()[[i]]
        alpha <- uploadFile[,3]
        r <- as.POSIXct(strptime(uploadFile[,2], "%Y-%m-%d %H:%M:%S", ""))
      } else if (!is.null(input[[paste0("Alpha_Subido2_", i)]])) {
        uploadFile <- AlphaSubido2()[[i]]
        alpha <- uploadFile[,3]
        r <- as.POSIXct(strptime(uploadFile[,2], "%Y-%m-%d %H:%M:%S", ""))
      } else {
        alpha <- alpha_sitio()[[i]]
        torre_ref <- torres_sitio()[[i]]
        r <- as.POSIXct(torre_ref$marcatemporal)
      }
      alpham <- data_frame(fecha=r,alpha=alpha)
      alphameses <- split(alpham, format(alpham$fecha, "%m"))
      
      for (i in 1:length(alphameses)) {
        df <- as.data.frame(matrix(ncol = 2,nrow = length(alphameses[[i]]$alpha)))
        df[,1] <- alphameses[[i]]$fecha
        df[,2] <- alphameses[[i]]$alpha
        alphameses[[i]] <- aggregate(V2~format(V1,"%H"), data=df, FUN=mean)
      }
      return(alphameses)
    })
  })
  
  observe({
    if (input$NumTorres!="") {
      input_btn <- paste0("RGUI_VD_", seq_len(as.numeric(input$NumTorres)))
      lapply(input_btn, function(i) {
        observeEvent(input[[i]], {
          j <- as.numeric(sub("RGUI_VD_", "", i))
          torre_ref <- torres_sitio()[[j]]
          if (length(torre_ref$series)<3) {
            output[[paste0("nivel1.plot_", j)]] <- renderPlot({
              velocidad1 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),vel=torre_ref$series[[1]]$data$v.prom)
              fecha_format <- "%Y/%m"
              if(difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>3650) {
                fecha_label <- "years"
                fecha_format <- "%Y"
              } else if (difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>1275) {
                fecha_label <- "6 months"
              } else if (difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>730) {
                fecha_label <- "3 months"
              } else if (difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>365) {
                fecha_label <- "2 months"
              } else {
                fecha_label <- "months"
              }
              velocidad1.plot <- ggplot(velocidad1, aes(date, vel)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$v.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de velocidad en el nivel inferior", x = "Fecha", y = "Velocidad [m/s]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              direccion1 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),dir=torre_ref$series[[1]]$data$dir.prom)
              
              direccion1.plot <- ggplot(direccion1, aes(date, dir)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$dir.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de Dirección en el nivel inferior", x = "Fecha", y = "Dirección [°]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              rosaViento1.plot <- rosaViento(spd = torre_ref$series[[1]]$data$v.prom, 
                                             dir = torre_ref$series[[1]]$data$dir.prom, dirres=22.5)
              
              ptlist <- list(velocidad1.plot,direccion1.plot,rosaViento1.plot)
              grid.arrange(grobs=ptlist,ncol=1,nrow=3)
            })
            
            output[[paste0("nivel2.plot_", j)]] <- renderPlot({
              velocidad2 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),vel=torre_ref$series[[2]]$data$v.prom)
              fecha_format <- "%Y/%m"
              if(difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>3650) {
                fecha_label <- "years"
                fecha_format <- "%Y"
              } else if (difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>1275) {
                fecha_label <- "6 months"
              } else if (difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>730) {
                fecha_label <- "3 months"
              } else if (difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>365) {
                fecha_label <- "2 months"
              } else {
                fecha_label <- "months"
              }
              velocidad2.plot <- ggplot(velocidad2, aes(date, vel)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[2]]$data$v.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de velocidad en el nivel inferior", x = "Fecha", y = "Velocidad [m/s]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              
              direccion2 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),dir=torre_ref$series[[2]]$data$dir.prom)
              
              direccion2.plot <- ggplot(direccion2, aes(date, dir)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[2]]$data$dir.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de Dirección en el nivel inferior", x = "Fecha", y = "Dirección [°]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              rosaViento2.plot <- rosaViento(spd = torre_ref$series[[2]]$data$v.prom, 
                                             dir = torre_ref$series[[2]]$data$dir.prom, dirres=22.5)
              
              ptlist <- list(velocidad2.plot,direccion2.plot,rosaViento2.plot)
              grid.arrange(grobs=ptlist,ncol=1,nrow=3)
            })
          } else {
            pruebadir1 <- torre_ref$series[[1]]$data$dir.prom
            pruebadir2 <- torre_ref$series[[2]]$data$dir.prom
            pruebadir3 <- torre_ref$series[[3]]$data$dir.prom
            output[[paste0("nivel1.plot_", j)]] <- renderPlot({
              velocidad1 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),vel=torre_ref$series[[1]]$data$v.prom)
              fecha_format <- "%Y/%m"
              if(difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>3650) {
                fecha_label <- "years"
                fecha_format <- "%Y"
              } else if (difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>1275) {
                fecha_label <- "6 months"
              } else if (difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>730) {
                fecha_label <- "3 months"
              } else if (difftime(velocidad1$date[length(velocidad1$date)], velocidad1$date[1], units = "days")>365) {
                fecha_label <- "2 months"
              } else {
                fecha_label <- "months"
              }
              velocidad1.plot <- ggplot(velocidad1, aes(date, vel)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$v.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de velocidad en el nivel inferior", x = "Fecha", y = "Velocidad [m/s]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              if (is.null(pruebadir1)) {
                direccion1.plot <- NULL 
              } else {
                direccion1 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),dir=pruebadir1)
                
                direccion1.plot <- ggplot(direccion1, aes(date, dir)) + 
                  geom_line(color='red') + 
                  coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$dir.prom))) +
                  scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                  scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
                  labs(title ="Serie de Dirección en el nivel inferior", x = "Fecha", y = "Dirección [°]") + 
                  theme_bw() + theme(text = element_text(size=20))
                
                rosaViento1.plot <- rosaViento(spd = torre_ref$series[[1]]$data$v.prom, 
                                               dir = torre_ref$series[[1]]$data$dir.prom, dirres=22.5)
              }
              if (is.null(direccion1.plot)) {
                ptlist <- list(velocidad1.plot)
                grid.arrange(grobs=ptlist,ncol=1,nrow=1)
              } else {
                ptlist <- list(velocidad1.plot,direccion1.plot,rosaViento1.plot)
                grid.arrange(grobs=ptlist,ncol=1,nrow=3)
              }
            })
            
            output[[paste0("nivel2.plot_", j)]] <- renderPlot({
              velocidad2 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),vel=torre_ref$series[[2]]$data$v.prom)
              fecha_format <- "%Y/%m"
              if(difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>3650) {
                fecha_label <- "years"
                fecha_format <- "%Y"
              } else if (difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>1275) {
                fecha_label <- "6 months"
              } else if (difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>730) {
                fecha_label <- "3 months"
              } else if (difftime(velocidad2$date[length(velocidad2$date)], velocidad2$date[1], units = "days")>365) {
                fecha_label <- "2 months"
              } else {
                fecha_label <- "months"
              }
              velocidad2.plot <- ggplot(velocidad2, aes(date, vel)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[2]]$data$v.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de velocidad en el nivel inferior", x = "Fecha", y = "Velocidad [m/s]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              if (is.null(pruebadir2)) {
                direccion2.plot <- NULL 
              } else {
                direccion2 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),dir=pruebadir2)
                
                direccion2.plot <- ggplot(direccion2, aes(date, dir)) + 
                  geom_line(color='red') + 
                  coord_cartesian(ylim=c(0,max(torre_ref$series[[2]]$data$dir.prom))) +
                  scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                  scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
                  labs(title ="Serie de Dirección en el nivel inferior", x = "Fecha", y = "Dirección [°]") + 
                  theme_bw() + theme(text = element_text(size=20))
                
                rosaViento2.plot <- rosaViento(spd = torre_ref$series[[2]]$data$v.prom, 
                                               dir = torre_ref$series[[2]]$data$dir.prom, dirres=22.5)
              }
              if (is.null(direccion2.plot)) {
                ptlist <- list(velocidad2.plot)
                grid.arrange(grobs=ptlist,ncol=1,nrow=1)
              } else {
                ptlist <- list(velocidad2.plot,direccion2.plot,rosaViento2.plot)
                grid.arrange(grobs=ptlist,ncol=1,nrow=3)
              }
            })
            
            output[[paste0("nivel3.plot_", j)]] <- renderPlot({
              velocidad3 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),vel=torre_ref$series[[3]]$data$v.prom)
              fecha_format <- "%Y/%m"
              if(difftime(velocidad3$date[length(velocidad3$date)], velocidad3$date[1], units = "days")>3650) {
                fecha_label <- "years"
                fecha_format <- "%Y"
              } else if (difftime(velocidad3$date[length(velocidad3$date)], velocidad3$date[1], units = "days")>1275) {
                fecha_label <- "6 months"
              } else if (difftime(velocidad3$date[length(velocidad3$date)], velocidad3$date[1], units = "days")>730) {
                fecha_label <- "3 months"
              } else if (difftime(velocidad3$date[length(velocidad3$date)], velocidad3$date[1], units = "days")>365) {
                fecha_label <- "2 months"
              } else {
                fecha_label <- "months"
              }
              velocidad3.plot <- ggplot(velocidad3, aes(date, vel)) + 
                geom_line(color='red') + 
                coord_cartesian(ylim=c(0,max(torre_ref$series[[3]]$data$v.prom))) +
                scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
                labs(title ="Serie de velocidad en el nivel inferior", x = "Fecha", y = "Velocidad [m/s]") + 
                theme_bw() + theme(text = element_text(size=20))
              
              if (is.null(pruebadir3)) {
                direccion3.plot <- NULL 
              } else {
                direccion3 <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),dir=pruebadir3)
                
                direccion3.plot <- ggplot(direccion3, aes(date, dir)) + 
                  geom_line(color='red') + 
                  coord_cartesian(ylim=c(0,max(torre_ref$series[[3]]$data$dir.prom))) +
                  scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
                  scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
                  labs(title ="Serie de Dirección en el nivel inferior", x = "Fecha", y = "Dirección [°]") + 
                  theme_bw() + theme(text = element_text(size=20))
                
                rosaViento3.plot <- rosaViento(spd = torre_ref$series[[3]]$data$v.prom, 
                                               dir = torre_ref$series[[3]]$data$dir.prom, dirres=22.5)
              }
              if (is.null(direccion3.plot)) {
                ptlist <- list(velocidad3.plot)
                grid.arrange(grobs=ptlist,ncol=1,nrow=1)
              } else {
                ptlist <- list(velocidad3.plot,direccion3.plot,rosaViento3.plot)
                grid.arrange(grobs=ptlist,ncol=1,nrow=3)
              }
            })
          }
          
          output[[paste0("UIVelocidadDireccion_", j)]] <- renderUI({
            if (input[[paste0("AltTVel_3_", j)]]=="Valor con punto decimal") {
              tagList(h4("Velocidad y Dirección Medida en Sitio: Nivel 1"),
                      plotOutput(paste0("nivel1.plot_",j), width = "100%", height = "1800px"),
                      h4("Velocidad y Dirección Medida en Sitio: Nivel 2"),
                      plotOutput(paste0("nivel2.plot_",j), width = "100%", height = "1800px")
              )
            } else {
              if (is.null(pruebadir1)) {
                tagList(h4("Velocidad Medida en Sitio: Nivel 1"),
                        plotOutput(paste0("nivel1.plot_",j), width = "100%", height = "600px"),
                        h4("Velocidad y Dirección Medida en Sitio: Nivel 2"),
                        plotOutput(paste0("nivel2.plot_",j), width = "100%", height = "1800px"),
                        h4("Velocidad y Dirección Medida en Sitio: Nivel 3"),
                        plotOutput(paste0("nivel3.plot_",j), width = "100%", height = "1800px")
                )
              } else if (is.null(pruebadir2)) {
                tagList(h4("Velocidad y Dirección Medida en Sitio: Nivel 1"),
                        plotOutput(paste0("nivel1.plot_",j), width = "100%", height = "1800px"),
                        h4("Velocidad Medida en Sitio: Nivel 2"),
                        plotOutput(paste0("nivel2.plot_",j), width = "100%", height = "600px"),
                        h4("Velocidad y Dirección Medida en Sitio: Nivel 3"),
                        plotOutput(paste0("nivel3.plot_",j), width = "100%", height = "1800px")
                )
              } else {
                tagList(h4("Velocidad y Dirección Medida en Sitio: Nivel 1"),
                        plotOutput(paste0("nivel1.plot_",j), width = "100%", height = "1800px"),
                        h4("Velocidad y Dirección Medida en Sitio: Nivel 2"),
                        plotOutput(paste0("nivel2.plot_",j), width = "100%", height = "1800px"),
                        h4("Velocidad Medida en Sitio: Nivel 3"),
                        plotOutput(paste0("nivel3.plot_",j), width = "100%", height = "600px")
                )
              }
            }
          })
        })
      })
    }
  })
  
  ## Se crea la torre con las fechas interpretadas y las series de temperatura, presión y humedad
  torres_met <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      shiny::validate(
        need(input[[paste0("AltTemp_", i)]] != "Valor con punto decimal", "Por favor, ingrese la altura de medición 
             correspondiente a los datos de cada torre meteorológica.")
      )
      shiny::validate(
        need(input[[paste0("LongTorre_", i)]] != "Valor con punto decimal", "Por favor, ingrese la coordenada de longitud 
             en grados decimales correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(input[[paste0("LatTorre_", i)]] != "Valor con punto decimal", "Por favor, ingrese la coordenada de latitud 
             en grados decimales correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(input[[paste0("RadRep_", i)]] != "Valor con punto decimal", "Por favor, ingrese el radio de representatividad 
             en kilómetros correspondiente a cada torre meteorológica.")
      )
      shiny::validate(
        need(datos_sitio_met()[[i]] != "", "Por favor, ingrese los datos de medición de cada torre meteorológica.")
      )
      datos_met <- datos_sitio_met()[[i]]
      shiny::validate(
        need(length(datos_met) > 5, "Los datos ingresados en el .csv no tienen la cantidad mínima de columnas requeridas. 
             Esto es un indicio de que las fechas no están siendo entregadas al aplicativo en el formato correcto.
             Recuerde que las fechas de las mediciones deben ser entregadas en columnas de año, mes, día, hora y minuto.")
      )
      date_string <- rep("",length(datos_met[,1]))
      hora_string <- rep("",length(datos_met[,1]))
      fecha_string <- rep("",length(datos_met[,1]))
      for (j in 1:length(datos_met[,1])) {
        date_string[j] <- paste(datos_met[,1][j], datos_met[,2][j], datos_met[,3][j], sep = "/")
        hora_string[j] <- paste(datos_met[,4][j], datos_met[,5][j], sep = ":")
        fecha_string[j] <- paste(date_string[j], hora_string[j], sep = " ")
      }
      ##Se reinterpreta la fecha y hora de los datos entregados en forma de un arreglo "string" y se convierten a uno "POSIXlt"
      fechas_sitio <- strptime(fecha_string, "%Y/%m/%d %H:%M", "")
      ##Se crean los objetos "serie" con la altura de medicion y la serie de temperatura, presión y humedad promedio
      serie <- serie(altura=as.numeric(input[[paste0("AltTemp_", i)]]), tmp=datos_met[,6], hum=datos_met[,7], press=datos_met[,8])
      ##Se retorna el objeto "torre" que representa una torre meteorologica.
      ##Contiene informacion de las serie suministradas para las fechas registradas.
      return(torre(marcatemporal = fechas_sitio, serie, 
                   pos=c(as.numeric(input[[paste0("LongTorre_", i)]]), as.numeric(input[[paste0("LatTorre_", i)]])),
                   radioRep=as.numeric(input[[paste0("RadRep_", i)]]), desc=paste0("Torre ", i)))
    })
  })
  
  observe({
    if (input$NumTorres!="") {
    input_btn <- paste0("RGUI_TPH_", seq_len(as.numeric(input$NumTorres)))
    lapply(input_btn, function(i) {
      observeEvent(input[[i]], {
        j <- as.numeric(sub("RGUI_TPH_", "", i))
        torre_ref <- torres_met()[[j]]
        temperatura <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),temp=torre_ref$series[[1]]$data$tmp)
        presion <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),press=torre_ref$series[[1]]$data$press)
        humedad <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),hum=torre_ref$series[[1]]$data$hum)
        fecha_format <- "%Y/%m"
        if(difftime(temperatura$date[length(temperatura$date)], temperatura$date[1], units = "days")>3650) {
          fecha_label <- "years"
          fecha_format <- "%Y"
        } else if (difftime(temperatura$date[length(temperatura$date)], temperatura$date[1], units = "days")>1275) {
          fecha_label <- "6 months"
        } else if (difftime(temperatura$date[length(temperatura$date)], temperatura$date[1], units = "days")>730) {
          fecha_label <- "3 months"
        } else if (difftime(temperatura$date[length(temperatura$date)], temperatura$date[1], units = "days")>365) {
          fecha_label <- "2 months"
        } else {
          fecha_label <- "months"
        }
        
        temperatura.plot <- ggplot(temperatura, aes(date, temp)) + 
          geom_line(color='red') + 
          coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$tmp))) +
          scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
          scale_y_continuous(breaks = seq(0, 50, by = 5), expand = c(0.0075,0.0075)) +
          labs(title ="Serie de Temperatura en sitio", x = "Fecha", y = "Temperatura [°C]") + 
          theme_bw() + theme(text = element_text(size=20))
        
        presion.plot <- ggplot(presion, aes(date, press)) + 
          geom_line(color='red') + 
          coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$press))) +
          scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
          scale_y_continuous(breaks = seq(0, 2000, by = 200), expand = c(0.0075,0.0075)) +
          labs(title ="Serie de Presión en sitio", x = "Fecha", y = "Presión [hPa]") + 
          theme_bw() + theme(text = element_text(size=20))
        
        humedad.plot <- ggplot(humedad, aes(date, hum)) + 
          geom_line(color='red') + 
          coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$hum))) +
          scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
          scale_y_continuous(breaks = seq(0, 100, by = 10), expand = c(0.0075,0.0075)) +
          labs(title ="Serie de Humedad Relativa en sitio", x = "Fecha", y = "Humedad Relativa [%]") + 
          theme_bw() + theme(text = element_text(size=20))
        
        output[[paste0("meteo.plot_", j)]] <- renderPlot({
          ptlist <- list(temperatura.plot,presion.plot,humedad.plot)
          grid.arrange(grobs=ptlist,ncol=1,nrow=3)
        })
      })
    })
    }
  })
  
  altura_minima <- reactive({
    datalturas <- VariasAlturas()
    shiny::validate(
      need(datalturas != "", "Por favor, suba un archivo con la información del parque eólico.")
    )
    diferentes <- unique(datalturas[,2])
    return(min(diferentes))
  })
  
  altura_maxima <- reactive({
    datalturas <- VariasAlturas()
    shiny::validate(
      need(datalturas != "", "Por favor, suba un archivo con la información del parque eólico.")
    )
    diferentes <- unique(datalturas[,2])
    return(max(diferentes))
  })
  
  densidades_sitio <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      torre_ref <- torres_met()[[i]]
      if (input$Altura_Cubo!="Valor con punto decimal") {
        return(rhositio(torre_ref,1,1,1,as.numeric(input$Altura_Cubo)))
      } else {
        datalturas <- VariasAlturas()
        shiny::validate(
          need(datalturas != "", "Por favor, suba un archivo con la información del parque eólico.")
        )
        diferentes <- unique(datalturas[,2])
        assign("rho_1", rhositio(torre_ref,1,1,1,diferentes[1]))
        densidades <- data.frame(cbind(rho_1))
        for (i in 2:length(diferentes)) {
          densidades[paste("rho_", i, sep = "")] <- rhositio(torre_ref,1,1,1,diferentes[i])
        }
        return(list(alturas=diferentes,densidades=densidades))
      }
    })
  })
  
  temperaturas <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      torre_ref <- torres_met()[[i]]
      if (input$Altura_Cubo!="Valor con punto decimal") {
        T_ref <- torre_ref$series[[1]]$data$tmp
        href <- torre_ref$series[[1]]$altura
        return(T_ref - 6.5*((as.numeric(input$Altura_Cubo)-href)/1000))
      } else {
        datalturas <- VariasAlturas()
        shiny::validate(
          need(datalturas != "", "Por favor, suba un archivo con la información del parque eólico.")
        )
        diferentes <- unique(datalturas[,2])
        T_ref <- torre_ref$series[[1]]$data$tmp
        href <- torre_ref$series[[1]]$altura
        TempIni <- T_ref - 6.5*((diferentes[1]-href)/1000)
        assign("T_1", TempIni)
        temperatures <- data.frame(cbind(T_1))
        for (i in 2:length(diferentes)) {
          temperatures[paste("T_", i, sep = "")] <- T_ref - 6.5*((diferentes[i]-href)/1000)
        }
        return(list(alturas=diferentes,temperaturas=temperatures))
      }
    })
  })
  
  observeEvent(input$RGUI_Densidad, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
      torre_ref <- torres_met()[[i]]
      densitio <- densidades_sitio()[[i]]
      
      output[[paste0("densidad.plot_", i)]] <- renderPlot({
        if (input$Altura_Cubo!="Valor con punto decimal") {
          densidad <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),rho=densitio)
          fecha_format <- "%Y/%m"
          if(difftime(densidad$date[length(densidad$date)], densidad$date[1], units = "days")>3650) {
            fecha_label <- "years"
            fecha_format <- "%Y"
          } else if (difftime(densidad$date[length(densidad$date)], densidad$date[1], units = "days")>1275) {
            fecha_label <- "6 months"
          } else if (difftime(densidad$date[length(densidad$date)], densidad$date[1], units = "days")>730) {
            fecha_label <- "3 months"
          } else if (difftime(densidad$date[length(densidad$date)], densidad$date[1], units = "days")>365) {
            fecha_label <- "2 months"
          } else {
            fecha_label <- "months"
          }
          
          ggplot(densidad, aes(date, rho)) + 
            geom_line(color='red') + 
            coord_cartesian(ylim=c(0,max(densitio))) +
            scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
            scale_y_continuous(breaks = seq(0, 2, by = 0.2), expand = c(0.0075,0.0075)) +
            labs(title ="Densidad en sitio a la altura del cubo", x = "Fecha", y = expression (Densidad~(kg/m^3))) +
            theme_bw() + theme(text = element_text(size=20))
        } else {
          alturaMin <- which.min(densitio$alturas)
          alturaMax <- which.max(densitio$alturas)
          densidadMin <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),rho=densitio$densidades[[alturaMin]])
          densidadMax <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),rho=densitio$densidades[[alturaMax]])
          fecha_format <- "%Y/%m"
          if(difftime(densidadMin$date[length(densidadMin$date)], densidadMin$date[1], units = "days")>3650) {
            fecha_label <- "years"
            fecha_format <- "%Y"
          } else if (difftime(densidadMin$date[length(densidadMin$date)], densidadMin$date[1], units = "days")>1275) {
            fecha_label <- "6 months"
          } else if (difftime(densidadMin$date[length(densidadMin$date)], densidadMin$date[1], units = "days")>730) {
            fecha_label <- "3 months"
          } else if (difftime(densidadMin$date[length(densidadMin$date)], densidadMin$date[1], units = "days")>365) {
            fecha_label <- "2 months"
          } else {
            fecha_label <- "months"
          }
          
          g1 <- ggplot(densidadMin, aes(date, rho)) + 
            geom_line(color='red') + 
            coord_cartesian(ylim=c(0,max(densitio$densidades[[alturaMin]]))) +
            scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
            scale_y_continuous(breaks = seq(0, 2, by = 0.2), expand = c(0.0075,0.0075)) +
            labs(title ="Densidad en sitio a la mínima altura del cubo", x = "Fecha", y = expression (Densidad~(kg/m^3))) +
            theme_bw() + theme(text = element_text(size=20))
          
          g2 <- ggplot(densidadMax, aes(date, rho)) + 
            geom_line(color='red') + 
            coord_cartesian(ylim=c(0,max(densitio$densidades[[alturaMax]]))) +
            scale_x_datetime(labels = date_format(fecha_format), breaks = date_breaks(fecha_label)) +
            scale_y_continuous(breaks = seq(0, 2, by = 0.2), expand = c(0.0075,0.0075)) +
            labs(title ="Densidad en sitio a la máxima altura del cubo", x = "Fecha", y = expression (Densidad~(kg/m^3))) +
            theme_bw() + theme(text = element_text(size=20))
          
          ptlist <- list(g1,g2)
          grid.arrange(grobs=ptlist,ncol=1,nrow=2)
        }
      })
      
      if (input$Altura_Cubo!="Valor con punto decimal") {
        output[[paste0("rhopromedios_", i)]] <- renderText({
          return(mean(densitio))
        })
      } else {
        output[[paste0("rhopromediovmin_", i)]] <- renderText({
          alturaMin <- which.min(densitio$alturas)
          return(mean(densitio$densidades[[alturaMin]]))
        })
        output[[paste0("rhopromediovmax_", i)]] <- renderText({
          alturaMax <- which.max(densitio$alturas)
          return(mean(densitio$densidades[[alturaMax]]))
        })
        output[[paste0("alturaminima_", i)]] <- renderText({
          altura_minima()
        })
        output[[paste0("alturamaxima_", i)]] <- renderText({
          altura_maxima()
        })
      }
    })
    
    output$UIdensidad <- renderUI({
      if (input$Altura_Cubo!="Valor con punto decimal") {
        tagList(
          lapply(1:as.numeric(input$NumTorres), function(i) {
            div(h4(paste0("Densidad Torre ", i)),
              plotOutput(paste0("densidad.plot_", i), width = "100%", height = "600px"),
            splitLayout(
              div(
                tags$div(
                  HTML(paste("La densidad promedio del aire en el sitio [kg/m", tags$sup(3), "] a la altura del cubo es igual a", sep = ""))
                )
              ),
              div(
                verbatimTextOutput(paste0("rhopromedios_", i), placeholder = TRUE)
              )
            ))
          })
        )
      } else {
        tagList(
          lapply(1:as.numeric(input$NumTorres), function(i) {
            div(h4(paste0("Densidad Torre ", i)),
              plotOutput(paste0("densidad.plot_", i), width = "100%", height = "1200px"),
              splitLayout(
                div(
                  tags$div(
                    HTML(paste("La densidad promedio del aire en el sitio [kg/m", tags$sup(3), "] a la altura de cubo mínima es igual a", sep = ""))
                  )
                ),
                div(
                  verbatimTextOutput(paste0("rhopromediovmin_", i), placeholder = TRUE)
                )
              ),
              splitLayout(
                div(
                  tags$div(
                    HTML(paste("Altura de cubo mínima en metros", sep = ""))
                  )
                ),
                div(
                  verbatimTextOutput(paste0("alturaminima_", i), placeholder = TRUE)
                )
              ),
              splitLayout(
                div(
                  tags$div(
                    HTML(paste("La densidad promedio del aire en el sitio [kg/m", tags$sup(3), "] a la altura de cubo máxima es igual a", sep = ""))
                  )
                ),
                div(
                  verbatimTextOutput(paste0("rhopromediovmax_", i), placeholder = TRUE)
                )
              ),
              splitLayout(
                div(
                  tags$div(
                    HTML(paste("Altura de cubo máxima en metros", sep = ""))
                  )
                ),
                div(
                  verbatimTextOutput(paste0("alturamaxima_", i), placeholder = TRUE)
                )
              ))
          })
        )
      }
    })
  })
  
  curvascorregidas <- reactive({
    csvOriginal <- curva_pot_emp()
    shiny::validate(
      need(input$Pot_nominal != "Valor con punto decimal", "Por favor, ingrese la potencia nominal de las 
           turbinas eólicas del parque eólico.")
      )
    shiny::validate(
      need(input$rho_fabricante != "Valor con punto decimal", "Por favor, ingrese la densidad que reporta el fabricante
           para las curvas de potencia y coeficiente de empuje.")
      )
    curva <- curvaPotencia(list(v=c(0,csvOriginal[[1]]), p=c(0,csvOriginal[[2]]), ct=c(0,csvOriginal[[3]])),
                           rho=as.numeric(input$rho_fabricante), rated.p=as.numeric(input$Pot_nominal))
    lapply(1:as.numeric(input$NumTorres), function(i) {
      if (input$Altura_Cubo!="Valor con punto decimal") {
        densitio <- mean(densidades_sitio()[[i]])
        shiny::validate(
          need(input$Vel_Salida != "Valor con punto decimal", "Por favor, ingrese la velocidad de salida de las 
               turbinas eólicas del parque eólico.")
          )
        return(curvaCorreccion(curva, attr(curva, 'rated.power'), as.numeric(input$Vel_Salida), attr(curva, 'rho'), densitio))
      } else {
        densitio <- densidades_sitio()[[i]]
        curvascorregidas <- list()
        for (i in 1:length(densitio$alturas)) {
          shiny::validate(
            need(input$Vel_Salida != "Valor con punto decimal", "Por favor, ingrese la velocidad de salida de las 
                 turbinas eólicas del parque eólico.")
            )
          curvascorregidas[[i]] <- curvaCorreccion(curva, attr(curva, 'rated.power'), as.numeric(input$Vel_Salida), 
                                                   attr(curva, 'rho'), mean(densitio$densidades[[i]]))
        }
        return(list(alturas=densitio$alturas,curvascorregidas=curvascorregidas))
      }
    })
  })
  
  observeEvent(input$RGUI_CurvaCorr, {
    csvCurva <- curva_pot_emp()
    
    lapply(1:as.numeric(input$NumTorres), function(i) {
      curvaCorr <- curvascorregidas()[[i]]
      output[[paste0("curvascorr.plot_", i)]] <- renderPlot({
        if (input$Altura_Cubo!="Valor con punto decimal") {
          CURVASPOT <- data.frame(vel_ori=c(0,csvCurva[[1]]),Pot_ori=c(0,csvCurva[[2]]),
                               vel_corr=curvaCorr$curvaPotencia$v,Pot_corr=curvaCorr$curvaPotencia$P)
        } else {
          alturaMax <- which.max(curvaCorr$alturas)
          CURVASPOT <- data.frame(vel_ori=c(0,csvCurva[[1]]),Pot_ori=c(0,csvCurva[[2]]),
                               vel_corr=curvaCorr$curvascorregidas[[alturaMax]]$curvaPotencia$v,
                               Pot_corr=curvaCorr$curvascorregidas[[alturaMax]]$curvaPotencia$P)
        }
        curvaPot <- ggplot(CURVASPOT, aes(color=Curvas)) + 
          geom_line(aes(x=vel_ori,y=Pot_ori, color="Fabricante"), size=1) +  
          geom_line(aes(x=vel_corr,y=Pot_corr, color="Corregida"), size=1) +
          coord_cartesian(xlim=c(0,as.numeric(input$Vel_Salida)), ylim=c(0,as.numeric(input$Pot_nominal))) +
          scale_x_continuous(expand = c(0,0.1)) +
          scale_y_continuous(breaks = seq(0, 10000, by = 200), expand = c(0.01,0.01)) +
          scale_color_manual(values=c("green", "red")) +
          labs(title ="Curvas de Potencia a la máxima altura de cubo", x = "Velocidad [m/s]", y = "Potencia [kW]") +
          theme_bw() + theme(text = element_text(size=20)) + 
          theme(legend.justification = c(1, 1), legend.position = c(0.95, 0.25)) +  
          theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
        
        if (input$Altura_Cubo!="Valor con punto decimal") {
          CURVASCT <- data.frame(vel_ori=c(0,csvCurva[[1]]),CT_ori=c(0,csvCurva[[3]]),
                               vel_corr=curvaCorr$curvaCT$v,CT_corr=curvaCorr$curvaCT$ct)
        } else {
          alturaMax <- which.max(curvaCorr$alturas)
          CURVASCT <- data.frame(vel_ori=c(0,csvCurva[[1]]),CT_ori=c(0,csvCurva[[3]]),
                               vel_corr=curvaCorr$curvascorregidas[[alturaMax]]$curvaCT$v,
                               CT_corr=curvaCorr$curvascorregidas[[alturaMax]]$curvaCT$ct)
        }
        
        curvaEmpuje <- ggplot(CURVASCT, aes(color=Curvas)) + 
          geom_line(aes(x=vel_ori,y=CT_ori, color="Fabricante"), size=1) +  
          geom_line(aes(x=vel_corr,y=CT_corr, color="Corregida"), size=1) +
          coord_cartesian(xlim=c(0,as.numeric(input$Vel_Salida)), ylim=c(0,1)) +
          scale_x_continuous(expand = c(0,0.1)) +
          scale_y_continuous(breaks = seq(0, 1, by = 0.2), expand = c(0.0075,0.0075)) +
          scale_color_manual(values=c("green", "red")) +
          labs(title ="Curvas de Coeficiente de Empuje a la máxima altura de cubo", x = "Velocidad [m/s]", y = "Coeficiente de Empuje [-]") +
          theme_bw() + theme(text = element_text(size=20)) + 
          theme(legend.justification = c(1, 1), legend.position = c(0.95, 0.95)) +  
          theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
        
        ptlist <- list(curvaPot,curvaEmpuje)
        grid.arrange(grobs=ptlist,ncol=1,nrow=2)
      })
    })
    
    output$UICorrecciones <- renderUI({
      lapply(1:as.numeric(input$NumTorres), function(i) {
        div(h4(paste0("Curvas Corregidas por Densidad de Torre ", i)),
            plotOutput(paste0("curvascorr.plot_", i), width = "100%", height="1200px")
        )
      })
    })
  })
  
  ## Lectura de .csv de la fuente secundaria de 10 años
  datos_secundario <- reactive({
    inFile <- input$fuente_secundaria
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    return(read.csv(inFile$datapath))
  })
  
  observeEvent(input$TablaSecundaria, {
    output$datos_sec.out <- DT::renderDataTable({
      csvCurva <- datos_secundario()
      shiny::validate(
        need(csvCurva != "", "Por favor seleccione una serie de datos")
      )
      csvCurva
    })
  })
  
  ## Se crea la torre con la información secundaria de velocidad y dirección para los 10 años
  torre_sec <- reactive({
    datos_sec <- datos_secundario()
    shiny::validate(
      need(datos_sec != "", "Por favor, ingrese los datos de la fuente secundaria.")
    )
    shiny::validate(
      need(length(datos_sec) > 5, "Los datos ingresados en el .csv no tienen la cantidad mínima de columnas requeridas. 
           Esto es un indicio de que las fechas no están siendo entregadas al aplicativo en el formato correcto.
           Recuerde que las fechas de las mediciones deben ser entregadas en columnas numéricas de año, mes, día, hora y minuto.")
      )
    shiny::validate(
      need(input$Alt_secundaria != "Valor con punto decimal", "Por favor, ingrese la altura de referencia
             correspondiente a los datos de la fuente secundaria.")
    )
    date_string <- rep("",length(datos_sec[,1]))
    hora_string <- rep("",length(datos_sec[,1]))
    fecha_string <- rep("",length(datos_sec[,1]))
    for (i in 1:length(datos_sec[,1])) {
      date_string[i] <- paste(datos_sec[,1][i], datos_sec[,2][i], datos_sec[,3][i], sep = "/")
      hora_string[i] <- paste(datos_sec[,4][i], datos_sec[,5][i], sep = ":")
      fecha_string[i] <- paste(date_string[i], hora_string[i], sep = " ")
    }
    ##Se reinterpreta la fecha y hora de los datos entregados en forma de un arreglo "string" y se convierten a uno "POSIXlt"
    fechas_sitio <- strptime(fecha_string, "%Y/%m/%d %H:%M", "")
    ##Se crean los objetos "serie" con la altura de medicion y la serie de velocidad y dirección promedio
    serie <- serie(altura=as.numeric(input$Alt_secundaria), v.prom=datos_sec[,6], dir.prom=datos_sec[,7])
    ##Se retorna el objeto "torre" que representa una torre meteorologica.
    ##Contiene informacion de las serie suministradas para las fechas registradas.
    return(torre(marcatemporal = fechas_sitio, serie))
  })
  
  ## Dibuja Velocidad Sec en el ActionButton
  velocidadsec.plot <- reactive({
    torre_ref <- torre_sec()
    velocidad <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),vel=torre_ref$series[[1]]$data$v.prom)
    
    ggplot(velocidad, aes(date, vel)) + 
      geom_line(color='red') + 
      coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$v.prom))) +
      scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
      scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
      labs(title ="Serie de velocidad de la fuente secundaria", x = "Fecha", y = "Velocidad [m/s]") + 
      theme_bw() + theme(text = element_text(size=20))
  })
  
  ## Dibuja Dirección Sec en el ActionButton
  direccionsec.plot <- reactive({
    torre_ref <- torre_sec()
    direccion <- data.frame(date=as.POSIXct(torre_ref$marcatemporal),dir=torre_ref$series[[1]]$data$dir.prom)
    
    ggplot(direccion, aes(date, dir)) + 
      geom_line(color='red') + 
      coord_cartesian(ylim=c(0,max(torre_ref$series[[1]]$data$dir.prom))) +
      scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
      scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
      labs(title ="Serie de Dirección de la fuente secundaria", x = "Fecha", y = "Dirección [°]") + 
      theme_bw() + theme(text = element_text(size=20))
  })
  
  ## Dibuja Rosa de Vientos Sec
  rosaVientosec.plot <- reactive({
    torre_ref <- torre_sec()
    rosaViento(spd = torre_ref$series[[1]]$data$v.prom, 
               dir = torre_ref$series[[1]]$data$dir.prom, dirres=22.5)
  })
  
  observeEvent(input$RGUI_SEC, {
    output$secundaria.plot <- renderPlot({
      ptlist <- list(velocidadsec.plot(),direccionsec.plot(),rosaVientosec.plot())
      grid.arrange(grobs=ptlist,ncol=1,nrow=3)
    })
  })
  
  ## Lectura de .csv de la fuente secundaria para el periodo comun
  datos_secomun <- reactive({
    inFile <- input$comun_secundaria
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    return(read.csv(inFile$datapath))
  })
  
  observeEvent(input$TablaSecundaria, {
    output$datos_secomun.out <- DT::renderDataTable({
      csvCurva <- datos_secomun()
      shiny::validate(
        need(csvCurva != "", "Por favor seleccione una serie de datos")
      )
      csvCurva
    })
  })
  
  ## Se crea la torre con la información secundaria de velocidad y dirección para el periodo común
  torre_secomun <- reactive({
    datos_secomun <- datos_secomun()
    shiny::validate(
      need(datos_secomun != "", "Por favor, ingrese los datos de la fuente secundaria para el período común.")
    )
    shiny::validate(
      need(input$Alt_secundaria != "Valor con punto decimal", "Por favor, ingrese la altura de referencia
           correspondiente a los datos de la fuente secundaria.")
    )
    shiny::validate(
      need(length(datos_secomun) > 5, "Los datos ingresados en el .csv no tienen la cantidad mínima de columnas requeridas. 
           Esto es un indicio de que las fechas no están siendo entregadas al aplicativo en el formato correcto.
           Recuerde que las fechas de las mediciones deben ser entregadas en columnas numéricas de año, mes, día, hora y minuto.")
    )
    date_string <- rep("",length(datos_secomun[,1]))
    hora_string <- rep("",length(datos_secomun[,1]))
    fecha_string <- rep("",length(datos_secomun[,1]))
    for (i in 1:length(datos_secomun[,1])) {
      date_string[i] <- paste(datos_secomun[,1][i], datos_secomun[,2][i], datos_secomun[,3][i], sep = "/")
      hora_string[i] <- paste(datos_secomun[,4][i], datos_secomun[,5][i], sep = ":")
      fecha_string[i] <- paste(date_string[i], hora_string[i], sep = " ")
    }
    ##Se reinterpreta la fecha y hora de los datos entregados en forma de un arreglo "string" y se convierten a uno "POSIXlt"
    fechas_sitio <- strptime(fecha_string, "%Y/%m/%d %H:%M", "")
    ##Se crean los objetos "serie" con la altura de medicion y la serie de velocidad y dirección promedio
    serie <- serie(altura=as.numeric(input$Alt_secundaria), v.prom=datos_secomun[,6], dir.prom=datos_secomun[,7])
    ##Se retorna el objeto "torre" que representa una torre meteorologica.
    ##Contiene informacion de las serie suministradas para las fechas registradas.
    return(torre(marcatemporal = fechas_sitio, serie))
  })
  
  ##Se ejecuta el MCP entre la serie de datos medidos en sitio y las fuentes secundarias.
  altura_ref_MCP <- reactive({
    torre_ref_sec <- torre_sec()
    torre_ref_secomun <- torre_secomun()
    lapply(1:as.numeric(input$NumTorres), function(i) {
      torre_ref_sitio <- torres_sitio()[[i]]
      if (!is.null(input[[paste0("Alpha_Subido_", i)]])) {
        uploadFile <- AlphaSubido()[[i]]
        alpha <- uploadFile[,3]
      } else if (!is.null(input[[paste0("Alpha_Subido2_", i)]])) {
        uploadFile <- AlphaSubido2()[[i]]
        alpha <- uploadFile[,3]
      } else {
        alpha <- alpha_sitio()[[i]]
      }
      alphameses <- alpha_meses()[[i]]
      
      if (input[[paste0("AltTVel_3_", i)]]=="Valor con punto decimal") {
        direcciones <- list(torre_ref_sitio$series[[1]]$data$dir.prom,torre_ref_sitio$series[[2]]$data$dir.prom)
      } else {
        direcciones <- list(torre_ref_sitio$series[[1]]$data$dir.prom,torre_ref_sitio$series[[2]]$data$dir.prom,
                            torre_ref_sitio$series[[3]]$data$dir.prom)
      }
      names(direcciones) <- seq_along(direcciones)
      direcciones <- Filter(Negate(is.null), direcciones)
      if (input$Nivel_Direccion=="Inferior") {
        seriesel <- direcciones[[1]]
      } else seriesel <- direcciones[[2]]
      
      return(MCP(torre_ref_sitio, torre_ref_sec, torre_ref_secomun,
                 as.numeric(input$Alt_secundaria), alpha, alphameses, seriesel, i))
    })
  })
  
  observeEvent(input$RGUI_MCP, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
      output[[paste0("correlacion_", i)]] <- renderText ({
        alturaRef <- altura_ref_MCP()[[i]]
        med_sitio <- read.csv(paste(getwd(), "/Serie_Sitio_Horaria-Torre", i, ".csv", sep = ""))
        med_secomun <- read.csv(paste(getwd(), "/Serie_Fuente_Secundaria_PeriodoComun-Torre", i, ".csv", sep = ""))
        round(cor(med_sitio$Velocidad,med_secomun$Velocidad),digits = 5)
      })
      output[[paste0("altura_recon_", i)]] <- renderText({
        altura_ref_MCP()[[i]]
      })
      
      output[[paste0("correlacion.plot_", i)]] <- renderPlot({
        med_sitio <- read.csv(paste(getwd(), "/Serie_Sitio_Horaria-Torre", i, ".csv", sep = ""))
        med_secomun <- read.csv(paste(getwd(), "/Serie_Fuente_Secundaria_PeriodoComun-Torre", i, ".csv", sep = ""))
        correlacion <- data.frame(vel_comun=med_secomun$Velocidad, vel_sitio=med_sitio$Velocidad)
        maximos <- c(max(med_secomun$Velocidad),max(med_sitio$Velocidad))
        ggplot(correlacion, aes(x=vel_comun, y=vel_sitio)) +
          geom_point() + coord_cartesian(xlim=c(0,max(maximos)), ylim=c(0,max(maximos))) +
          scale_x_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) + 
          scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
          labs(title ="Correlacion de los datos", x = "Velocidad Secundaria [m/s]", y = "Velocidad en Sitio [m/s]") +
          theme_bw() + theme(text = element_text(size=20))
      })
      
      output[[paste0("comparacionsinvel.plot_", i)]] <- renderPlot({
        med_sitio <- read.csv(paste(getwd(), "/Serie_Sitio_Horaria-Torre", i, ".csv", sep = ""))
        med_secomun <- read.csv(paste(getwd(), "/Serie_Fuente_Secundaria_PeriodoComun-Torre", i, ".csv", sep = ""))
        fechas_comun <- strptime(med_sitio[,2], "%Y-%m-%d %H:%M:%S", "")
        compa <- data.frame(date=as.POSIXct(fechas_comun),vel_sitio=med_sitio$Velocidad,vel_secomun=med_secomun$Velocidad)
        maximos <- c(max(med_secomun$Velocidad),max(med_sitio$Velocidad))
        
        ggplot(compa, aes(x=date, color=Velocidades)) + 
          geom_line(aes(y=vel_sitio, color="En Sitio")) + geom_line(aes(y=vel_secomun, color="Secundaria")) +
          coord_cartesian(ylim=c(0,max(maximos))) +
          scale_x_datetime(labels = date_format("%Y/%m"), breaks = date_breaks("months")) +
          scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
          scale_color_manual(values=c("black","red")) +
          labs(title ="Comparación de Velocidad en Sitio y Fuente Secundaria", x = "Fecha", y = "Velocidad [m/s]") + 
          theme_bw() + theme(text = element_text(size=20)) + 
          theme(legend.justification = c(1, 1), legend.position = c(1, 0.25)) +  
          theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
      })
      
      output[[paste0("comparacionsindir.plot_", i)]] <- renderPlot({
        med_sitio <- read.csv(paste(getwd(), "/Serie_Sitio_Horaria-Torre", i, ".csv", sep = ""))
        med_secomun <- read.csv(paste(getwd(), "/Serie_Fuente_Secundaria_PeriodoComun-Torre", i, ".csv", sep = ""))
        fechas_comun <- strptime(med_sitio[,2], "%Y-%m-%d %H:%M:%S", "")
        compa <- data.frame(date=as.POSIXct(fechas_comun),dir_sitio=med_sitio$Direccion,dir_secomun=med_secomun$Direccion)
        maximos <- c(max(med_secomun$Direccion),max(med_sitio$Direccion))
        
        ggplot(compa, aes(x=date, color=Direcciones)) + 
          geom_line(aes(y=dir_sitio, color="En Sitio")) + geom_line(aes(y=dir_secomun, color="Secundaria")) +
          coord_cartesian(ylim=c(0,max(maximos))) +
          scale_x_datetime(labels = date_format("%Y/%m"), breaks = date_breaks("months")) +
          scale_y_continuous(breaks = seq(0, 360, by = 30), expand = c(0.0075,0.0075)) +
          scale_color_manual(values=c("black","red")) +
          labs(title ="Comparación de Dirección en Sitio y Fuente Secundaria", x = "Fecha", y = "Dirección [º]") + 
          theme_bw() + theme(text = element_text(size=20)) + 
          theme(legend.justification = c(1, 1), legend.position = c(1, 1)) +  
          theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
      })
      
      output[[paste0("comparacionorirec.plot_", i)]] <- renderPlot({
        reconstruccion <- read.csv(paste(getwd(), "/RECONSTRUCCION-Torre", i, ".csv", sep = ""))
        fuente_sec <- read.csv(paste(getwd(), "/Serie_Fuente_Secundaria-Torre", i, ".csv", sep = ""))
        fechas_todo <- strptime(fuente_sec[,2], "%Y-%m-%d %H:%M:%S", "")
        compa <- data.frame(date=as.POSIXct(fechas_todo),vel_rec=reconstruccion$Vel_RC,vel_sec=fuente_sec$Velocidad)
        maximos <- c(max(reconstruccion$Vel_RC),max(fuente_sec$Velocidad))
        
        ggplot(compa, aes(x=date, color=Velocidades)) + 
          geom_line(aes(y=vel_rec, color="Reconstruccion")) + geom_line(aes(y=vel_sec, color="Secundaria")) +
          coord_cartesian(ylim=c(0,max(maximos))) +
          scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
          scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
          scale_color_manual(values=c("black","red")) +
          labs(title ="Comparación de Velocidad de Fuente Secundaria y Reconstruida", x = "Fecha", y = "Velocidad [m/s]") + 
          theme_bw() + theme(text = element_text(size=20)) + 
          theme(legend.justification = c(1, 1), legend.position = c(0.99, 0.99)) +  
          theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
      })
      
      output[[paste0("descargarRecons_", i)]] <- downloadHandler(
        filename = function(){
          paste0("Reconstruccion-Torre", i, "@", altura_ref_MCP()[[i]],"m-", Sys.Date(), ".csv", sep="")
        },
        content = function(file) {
          reconstruccion <- read.csv(paste(getwd(), "/RECONSTRUCCION-Torre", i, ".csv", sep = ""))
          DownLoadData <- reconstruccion;
          write.csv(x = DownLoadData, file = file)
        }
      )
    })
    
    output$UIMCPs <- renderUI({
      lapply(1:as.numeric(input$NumTorres), function(i) {
        div(h4(paste0("Reconstrucción Histórica para la Torre ", i)),
            tags$div(
              HTML("El coeficiente de correlación r entre las mediciones en sitio y la fuente secundaria es igual a:")
            ),
            verbatimTextOutput(paste0("correlacion_", i), placeholder = TRUE), align="center",
            plotOutput(paste0("correlacion.plot_", i), width = "75%", height = "600px"),
            plotOutput(paste0("comparacionsinvel.plot_", i), width = "100%", height = "600px"),
            plotOutput(paste0("comparacionsindir.plot_", i), width = "100%", height = "600px"),
            plotOutput(paste0("comparacionorirec.plot_", i), width = "100%", height = "600px"),
            tags$div(
              HTML("La altura de la reconstrucción historica en metros [m] es igual a:")
            ),
            verbatimTextOutput(paste0("altura_recon_", i), placeholder = TRUE)
        )
      })
    })
    
    output$UIMCPMCP <- renderUI({
      div(
        uiOutput("UIMCPs"),
        p(
          lapply(1:as.numeric(input$NumTorres), function(i) {
            div(br(),
                downloadButton(paste0("descargarRecons_", i), paste0("Descargar Reconstrucción Histórica de Velocidad y Dirección de Torre ", i))
            )
          })
        ))
    })
  })
  
  observeEvent(input$Subir_paraEstelas, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
      output[[paste0("cadaSubidaEstelas_", i)]] <- renderUI({
        div(
          fileInput(inputId=paste0("Alpha_Subido2_", i), 
                    label = paste0("Cargue el archivo .csv que descargó en el botón 
                                   ''Descargar Serie de Coeficiente de Cortante de Torre ", i, "'' del Paso 2."),
                    multiple = FALSE, accept = c(".csv"), buttonLabel = "Explorar..."),
          fileInput(inputId=paste0("Reconstruccion_Subido_", i), 
                    label = paste0("Cargue el archivo .csv que descargó en el botón 
                                   ''Descargar Reconstrucción Histórica de Velocidad y Dirección de Torre", i, "'' del Paso 3."),
                    multiple = FALSE, accept = c(".csv"), buttonLabel = "Explorar..."),
          textInput(inputId= paste0("Altura_IN_MCP_", i), label = paste0("¿Cuál es la altura de referencia de la reconstrucción de la Torre ", 
                                                                         i, " reportada en el Paso 3 [m]?"),
                    "Valor con punto decimal")
        )
      })
    })
    
    output$uiSubirESTELA <- renderUI({
      lapply(1:as.numeric(input$NumTorres), function(i) {
        uiOutput(paste0("cadaSubidaEstelas_", i))
      })
    })
  })
  
  ReconstruccionSubido <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      inFile <- input[[paste0("Reconstruccion_Subido_", i)]]
      if (is.null(inFile)){return(NULL)}
      shiny::validate(
        need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
      )
      CsVRead <- read.csv(inFile$datapath)
      CsVRead$X <- NULL
      return(CsVRead)
    })
  })
  
  ReconstruccionSubido2 <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      inFile <- input[[paste0("Reconstruccion_Subido2_", i)]]
      if (is.null(inFile)){return(NULL)}
      shiny::validate(
        need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
      )
      CsVRead <- read.csv(inFile$datapath)
      CsVRead$X <- NULL
      return(CsVRead)
    })
  })
  
  Vel_cubo_recon <- reactive({
    lapply(1:as.numeric(input$NumTorres), function(i) {
      if (!is.null(input[[paste0("Reconstruccion_Subido_", i)]])) {
        reconstruccion <- ReconstruccionSubido()[[i]]
        ALTURAREF <- as.numeric(input[[paste0("Altura_IN_MCP_", i)]])
      } else if (!is.null(input[[paste0("Reconstruccion_Subido2_", i)]])) {
        reconstruccion <- ReconstruccionSubido2()[[i]]
        ALTURAREF <- as.numeric(input[[paste0("Altura_IN_MCP2_", i)]])
      } else {
        reconstruccion <- read.csv(paste(getwd(), "/RECONSTRUCCION-Torre", i, ".csv", sep = ""))
        ALTURAREF <- altura_ref_MCP()[[i]]
      }
      
      fechaMCP <- strptime(reconstruccion[,2], "%Y-%m-%d %H:%M:%S", "")
      Vel_Cubo <- reconstruccion[,3]
      if (input$Altura_Cubo!="Valor con punto decimal") {
        if (ALTURAREF==as.numeric(input$Altura_Cubo)) {
          return(Vel_Cubo)
        } else {
          alphameses <- alpha_meses()[[i]]
          #Se extrapola la reconstrucción hasta la altura del cubo de la turbina eólica
          for (j in 1:length(Vel_Cubo)) {
            mMCP <- format(fechaMCP[j], "%m")
            hMCP <- as.numeric(format(fechaMCP[j], "%H"))+1
            Vel_Cubo[j] <- reconstruccion[,3][j]*
              (as.numeric(input$Altura_Cubo)/ALTURAREF)^alphameses[[mMCP]][,2][hMCP]
          }
          return(Vel_Cubo)
        }
      } else {
        datalturas <- VariasAlturas()
        shiny::validate(
          need(datalturas != "", "Por favor, suba un archivo con la información del parque eólico.")
        )
        diferentes <- unique(datalturas[,2])
        alphameses <- alpha_meses()[[i]]
        for (j in 1:length(Vel_Cubo)) {
          mMCP <- format(fechaMCP[j], "%m")
          hMCP <- as.numeric(format(fechaMCP[j], "%H"))+1
          Vel_Cubo[j] <- reconstruccion[,3][j]*(diferentes[1]/ALTURAREF)^alphameses[[mMCP]][,2][hMCP]
        }
        assign("VelExtrapolada_1", Vel_Cubo)
        VelocidadesExt <- data.frame(cbind(VelExtrapolada_1))
        for (j in 2:length(diferentes)) {
          for (k in 1:length(Vel_Cubo)) {
            mMCP <- format(fechaMCP[k], "%m")
            hMCP <- as.numeric(format(fechaMCP[k], "%H"))+1
            Vel_Cubo[k] <- reconstruccion[,3][k]*(diferentes[j]/ALTURAREF)^alphameses[[mMCP]][,2][hMCP]
          }
          VelocidadesExt[paste("VelExtrapolada_", j, sep = "")] <- Vel_Cubo
        }
        return(list(alturas=diferentes,Velocidades=VelocidadesExt))
      }
    })
  })
  
  observeEvent(input$Velocidad_Extrapolada, {
    lapply(1:as.numeric(input$NumTorres), function(i) {
    output[[paste0("descargarVelExt_", i)]] <- downloadHandler(
      filename = function(){
        paste0("VelocidadesExtrapoladas-Torre", i,"-", Sys.Date(), ".csv", sep="")
      },
      content = function(file) {
        if (!is.null(input$Reconstruccion_Subido_1)) {
          reconstruccion <- ReconstruccionSubido()
        } else if (!is.null(input$Reconstruccion_Subido2_1)) {
          reconstruccion <- ReconstruccionSubido2()
        } else {
          reconstruccion <- lapply(1:as.numeric(input$NumTorres), function(i) {
            return(read.csv(paste(getwd(), "/RECONSTRUCCION-Torre", i, ".csv", sep = "")))
          })
        }
        Vel_Cubo <- Vel_cubo_recon()
        if (input$Altura_Cubo!="Valor con punto decimal") {
          altCubo <- as.numeric(input$Altura_Cubo)
          DownLoadData <- data.frame(strptime(reconstruccion[[1]][,2], "%Y-%m-%d %H:%M:%S", ""),Vel_Cubo[[i]])
          colnames(DownLoadData)[1] <- "Fecha";
          colnames(DownLoadData)[2] <- paste0("Velocidad(m/s)@",altCubo,"m");
        } else {
          DownLoadData <- data.frame(strptime(reconstruccion[[1]][,2], "%Y-%m-%d %H:%M:%S", ""))
          colnames(DownLoadData)[1] <- "Fecha";
          for (j in 1:length(Vel_Cubo[[i]]$alturas)) {
            DownLoadData <- cbind(DownLoadData,Vel_Cubo[[i]]$Velocidades[[j]])
            colnames(DownLoadData)[j+1] <- paste0("Velocidad(m/s)@",Vel_Cubo[[i]]$alturas[[j]],"m");
          }
        }
        write.csv(x = DownLoadData, file = file)
      }
    )
    })
    output$uiVelocidadExtrapolada <- renderUI({
      div(
        p(
          lapply(1:as.numeric(input$NumTorres), function(i) {
            div(br(),
                downloadButton(paste0("descargarVelExt_", i), paste0("Descargar Velocidades Extrapoladas Libres de la Torre ", i))
            )
          })
        ))
    })
  })
  
  Vel_estelas <- reactive({
    if (!is.null(input$Reconstruccion_Subido_1)) {
      reconstruccion <- ReconstruccionSubido()
    } else if (!is.null(input$Reconstruccion_Subido2_1)) {
      reconstruccion <- ReconstruccionSubido2()
    } else {
      reconstruccion <- lapply(1:as.numeric(input$NumTorres), function(i) {
        return(read.csv(paste(getwd(), "/RECONSTRUCCION-Torre", i, ".csv", sep = "")))
      })
    }
    Vel_Cubo <- Vel_cubo_recon()
    parque <- parqueEolico()
    diametro <- as.numeric(input$Diam_Turb)
    shiny::validate(
      need(diametro != "Valor con punto decimal", "Por favor, ingrese el diámetro de las turbinas eólicas del parque.")
    )
    torres_ref <- torres_met()
    densitio <- densidades_sitio()
    curvascorregidas <- curvascorregidas()
    if (input$On_Offshore=="Dentro de Costa (k = 0.075)") {
      on_or_offshore = TRUE
    } else on_or_offshore = FALSE
    
    if(input$Rugosidad_Aumentada=="Valor con punto decimal") {
      if (input$Altura_Cubo!="Valor con punto decimal") {
        altCubo <- as.numeric(input$Altura_Cubo)
        return(velocidadEstela(reconstruccion, torres_ref, Vel_Cubo, densitio, parque,
                               curvascorregidas, diametro, altCubo, on_or_offshore))
      } else {
        altCubo <- VariasAlturas()
        shiny::validate(
          need(altCubo != "", "Por favor, suba un archivo con la alturas de cubo de las turbinas del parque eólico.")
        )
        return(velocidadEstelaVarAlt(reconstruccion, torres_ref, Vel_Cubo, densitio, parque, 
                                     curvascorregidas, diametro, altCubo, on_or_offshore))
      }
    } else {
      if(input$Cortante_Parques=="Cálculo a partir de Cortante de Viento en Sitio") {
        alpha_cadaTorre <- rep(0,as.numeric(input$NumTorres))
        lapply(1:as.numeric(input$NumTorres), function(i) {
          if (!is.null(input[[paste0("Alpha_Subido_", i)]])) {
            uploadFile <- AlphaSubido()[[i]]
            alpha <- uploadFile[,3]
            alpha_cadaTorre[i] <- mean(alpha)
          } else if (!is.null(input[[paste0("Alpha_Subido2_", i)]])) {
            uploadFile <- AlphaSubido2()[[i]]
            alpha <- uploadFile[,3]
            alpha_cadaTorre[i] <- mean(alpha)
          } else {
            alpha <- alpha_sitio()[[i]]
            alpha_cadaTorre[i] <- mean(alpha)
          }
        })
        #Se halla la rugosidad promedio del parque partiendo del cortante alpha y la relación de Counihan
        alpha_Parque <- mean(alpha_cadaTorre)
        if(alpha_Parque<0.096) {
          counihan_des <- function(z_0,alpha) (0.096*log10(z_0) + (0.016*(log10(z_0))^(2)) + 0.24 - alpha)
          z_01 <- uniroot(f=counihan_des,interval=c(0.001,10),alpha=alpha_Parque)$root
        } else z_01 <- 0.0002
      } else {
        if (input$On_Offshore=="Dentro de Costa (k = 0.075)") {
          z_01 <- 0.055
        } else z_01 <- 0.0002
      }
      
      shiny::validate(
        need(input$Rugosidad_Aumentada != "Valor con punto decimal", "Por favor, ingrese la rugosidad aumentada del parque eólico.")
      )
      z_02 <- z_01 + as.numeric(input$Rugosidad_Aumentada)
      if (input$Altura_Cubo!="Valor con punto decimal") {
        altCubo <- as.numeric(input$Altura_Cubo)
        return(velocidadEstela_GranPar(reconstruccion, torres_ref, Vel_Cubo, densitio, parque,
                               curvascorregidas, diametro, altCubo, on_or_offshore, z_01, z_02))
      } else {
        altCubo <- VariasAlturas()
        shiny::validate(
          need(altCubo != "", "Por favor, suba un archivo con la información del parque eólico.")
        )
        return(velocidadEstelaVarAlt_GranPar(reconstruccion, torres_ref, Vel_Cubo, densitio, parque, 
                                     curvascorregidas, diametro, altCubo, on_or_offshore, z_01, z_02))
      }
    }
  })
  
  observeEvent(input$RGUI_ESTELA, {
    output$comparacionEstela.plot <- renderPlot({
      matrizEstela <- Vel_estelas()
      ejefecha <- matrizEstela[,1]
      VelSinFecha <- matrizEstela
      VelSinFecha$Fecha <- NULL
      turb_mas_afect <- rep(0,length(VelSinFecha))
      for(i in 1:length(VelSinFecha)) {
        turb_mas_afect[i] <- VelSinFecha[[i]][1]
      }
      ind_max <- which.max(turb_mas_afect)
      ind_min <- which.min(turb_mas_afect)
      VelSin <- VelSinFecha[[ind_max]]
      VelAfectada <- VelSinFecha[[ind_min]]
      
      compa <- data.frame(date=ejefecha[1:170],vel_sin=VelSin[1:170],vel_afec=VelAfectada[1:170])
      maximos <- c(max(VelSin[1:170]),max(VelAfectada[1:170]))
      
      if (!is.na(max(maximos))) {
        maxusa <- max(maximos)
      } else if (!is.na(maximos[1])||!is.na(maximos[2])) {
        maxusa <- min(maximos)
      } else maxusa <- 22
      
      ggplot(compa, aes(x=date, color=Velocidades)) + 
        geom_line(aes(y=vel_sin, color="NO Afectada por Estela"),size=1) + 
        geom_line(aes(y=vel_afec, color="Afectada por Estela"),size=1) +
        coord_cartesian(ylim=c(0,maxusa)) +
        scale_x_datetime(labels = date_format("%Y/%m/%d"), breaks = date_breaks("days")) +
        scale_y_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) +
        scale_color_manual(values=c("black","red")) +
        labs(title ="Comparación de Velocidad de Fuente Secundaria y Reconstruida", x = "Fecha", y = "Velocidad [m/s]") + 
        theme_bw() + theme(text = element_text(size=20)) + 
        theme(legend.justification = c(1, 1), legend.position = c(1, 0.25)) +  
        theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
    })
  })
  
  output$descargarVelEstelas <- downloadHandler(
    filename = function(){
      paste0("VelocidadesAfectadasEstela-", Sys.Date(), ".csv", sep="")
    },
    content = function(file) {
      velEstelas <- Vel_estelas()
      DownLoadData <- velEstelas;
      write.csv(x = DownLoadData, file = file)
    }
  )
  
  VelEstelasSubido <- reactive({
    inFile <- input$Vel_TURBINAS
    if (is.null(inFile)){return(NULL)}
    shiny::validate(
      need(expr = grepl(pattern = ".csv",x = inFile), message = "El archivo debe estar en formato .csv")
    )
    CsVRead <- read.csv(inFile$datapath)
    CsVRead$X <- NULL
    return(CsVRead)
  })
  
  Energia_Horaria_Turbina <- reactive({
    if (!is.null(input$Vel_TURBINAS)) {
      vel_estelas <- VelEstelasSubido()
      fechaSubida <- TRUE
    } else {
      vel_estelas <- Vel_estelas()
      fechaSubida <- FALSE
    }
    
    fecha_recon <- vel_estelas[,1]
    vel_estelas[[1]] <- NULL
    vel_estelas[[1]] <- NULL
    curvascorregidas <- curvascorregidas()
    parque <- parqueEolico()
    torres_ref <- torres_met()
    densitio <- densidades_sitio()
    tempExt <- temperaturas()
    shiny::validate(
      need(input$Temp_Min != "Valor con punto decimal", "Por favor, ingrese la temperatura mínima de operación de las turbinas eólicas del parque.")
    )
    shiny::validate(
      need(input$Temp_Max != "Valor con punto decimal", "Por favor, ingrese la temperatura máxima de operación de las turbinas eólicas del parque.")
    )
    
    if (!is.null(input$Cableado)) {
      PCC <- c(as.numeric(input$LongPCC),as.numeric(input$LatPCC), as.numeric(input$AltPCC))
      shiny::validate(
        need(PCC != "", "Para realizar el cálculo de pérdidas debe ingresar el trazado eléctrico y 
             las coordenadas del Punto de Conexión Común.")
        )
      shiny::validate(
        need(input$Resistencia != "Valor con punto decimal", "Por favor, ingrese la resistencia de la red eléctrica del parque.")
      )
      shiny::validate(
        need(input$Voltaje != "Valor con punto decimal", "Por favor, ingrese el voltaje de la red eléctrica del parque.")
      )
      DistanciasCableado <- CableDisTurbinas(parque, PCC, trazadoElectrico())
      if (input$Altura_Cubo!="Valor con punto decimal") {
        return(Energia_Mensual_conPer(fecha_recon, fechaSubida, torres_ref, densitio, tempExt, vel_estelas, curvascorregidas, 
                                      parque, as.numeric(input$Pot_nominal), as.numeric(input$Temp_Min), as.numeric(input$Temp_Max), 
                                      DistanciasCableado, as.numeric(input$Resistencia), as.numeric(input$Voltaje), 1))
      } else {
        altCubo <- VariasAlturas()
        shiny::validate(
          need(altCubo != "", "Por favor, suba un archivo con la información del parque eólico.")
        )
        return(Energia_MensualVarAlt_conPer(fecha_recon, fechaSubida, torres_ref, densitio, tempExt, vel_estelas, curvascorregidas, 
                                            parque, altCubo, as.numeric(input$Pot_nominal), as.numeric(input$Temp_Min), as.numeric(input$Temp_Max), 
                                            DistanciasCableado, as.numeric(input$Resistencia), as.numeric(input$Voltaje), 1))
      }
    } else {
      if (input$Altura_Cubo!="Valor con punto decimal") {
        return(Energia_Mensual_sinPer(fecha_recon, fechaSubida, torres_ref, densitio, tempExt, vel_estelas, curvascorregidas, 
                                      parque, as.numeric(input$Pot_nominal), as.numeric(input$Temp_Min), as.numeric(input$Temp_Max), 1))
      } else {
        altCubo <- VariasAlturas()
        shiny::validate(
          need(altCubo != "", "Por favor, suba un archivo con la información del parque eólico.")
        )
        return(Energia_MensualVarAlt_sinPer(fecha_recon, fechaSubida, torres_ref, densitio, tempExt, vel_estelas, curvascorregidas, 
                                            parque, altCubo, as.numeric(input$Pot_nominal), as.numeric(input$Temp_Min), as.numeric(input$Temp_Max), 1))
      }
      
    }
    
  })
  
  Energia_PARQUE <- reactive({
    E_hor <- Energia_Horaria_Turbina()
    fechaRECON <- E_hor[,1]
    E_hor[[1]] <- NULL
    parque <- parqueEolico()
    #Se genera una sola serie temporal de energía generada como la suma de todas las turbinas con las fechas correspondientes
    ##Se inicializa con la información de la primera turbina
    assign("Energia_Generada_Horaria", E_hor[,1])
    Eparque_hor <- data.frame(cbind(Energia_Generada_Horaria))
    for (i in 2:length(parque[[1]])){
      Eparque_hor <- Eparque_hor+E_hor[,i]
    }
    #Se calcula el ENFICC, lo cual incluye separar los datos por meses y sumar los valores dentro cada uno
    Eparque <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),energia=Eparque_hor[,1])
    e_meses <- Eparque %>% group_by(month=floor_date(fecha, "month")) %>%
      summarize(energia=sum(energia))
    e_meses2 <- as.numeric(unlist(e_meses[2]))
    
    fechameses <- seq(from=as.POSIXct(fechaRECON[1]),to=as.POSIXct(fechaRECON[length(fechaRECON)]), by="month")
    E_MWh_dia <- rep(0,length(fechameses))
    for (i in 1:length(fechameses)) {
      E_MWh_dia[i] <- e_meses2[i]/days_in_month(fechameses[i])
    }
    
    return(E_MWh_dia)
  })
  
  energiaParqueHistorico <- reactive({
    E_hor <- Energia_Horaria_Turbina()
    fechas <- E_hor[,1]
    E_hor[[1]] <- NULL
    parque <- parqueEolico()
    #Se genera una sola serie temporal de energía generada como la suma de todas las turbinas con las fechas correspondientes
    ##Se inicializa con la información de la primera turbina
    assign("Energia_Generada_Horaria", E_hor[,1])
    Eparque_hor <- data.frame(cbind(Energia_Generada_Horaria))
    for (i in 2:length(parque[[1]])){
      Eparque_hor <- Eparque_hor+E_hor[,i]
    }
    for (i in 1:length(fechas)){
      Eparque_hor[[1]][i] <- Eparque_hor[[1]][i]/days_in_month(fechas[i])
    }
    eParque1 <- data.frame(date=fechas[1:(length(fechas)/5)],enel=Eparque_hor[[1]][1:(length(fechas)/5)])
    eParque2 <- data.frame(date=fechas[(length(fechas)/5):(length(fechas)*2/5)],enel=Eparque_hor[[1]][(length(fechas)/5):(length(fechas)*2/5)])
    eParque3 <- data.frame(date=fechas[(length(fechas)*2/5):(length(fechas)*3/5)],enel=Eparque_hor[[1]][(length(fechas)*2/5):(length(fechas)*3/5)])
    eParque4 <- data.frame(date=fechas[(length(fechas)*3/5):(length(fechas)*4/5)],enel=Eparque_hor[[1]][(length(fechas)*3/5):(length(fechas)*4/5)])
    eParque5 <- data.frame(date=fechas[(length(fechas)*4/5):(length(fechas))],enel=Eparque_hor[[1]][(length(fechas)*4/5):(length(fechas))])
    
    return(list(eParque1=eParque1,eParque2=eParque2,eParque3=eParque3,eParque4=eParque4,eParque5=eParque5))
  })
  
  observeEvent(input$RGUI_EneFinal, {
    output$ePH.plot1 <- renderPlot({
      eParque <- energiaParqueHistorico()$eParque1
      fechanios <- seq(from=eParque$date[1],to=eParque$date[length(eParque$date)], by="year")
      fechanios <- format(fechanios,"%Y")
      
      ggplot(eParque, aes(date, enel)) + 
        geom_line(color='red', size=0.5) + 
        coord_cartesian(ylim=c(0,max(eParque$enel))) +
        scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
        scale_y_continuous(breaks = seq(0, 5, by = 0.2), expand = c(0.0075,0.0075)) +
        labs(title =paste0("Energía Horaria Generada en el Parque (",fechanios[1],"-",fechanios[2],")"), 
             x = "Fecha", y = "Energía Generada [MWh/dia]") + 
        theme_bw() + theme(text = element_text(size=20))
    })
    output$ePH.plot2 <- renderPlot({
      eParque <- energiaParqueHistorico()$eParque2
      fechanios <- seq(from=(eParque$date[100]),to=eParque$date[length(eParque$date)], by="year")
      fechanios <- format(fechanios,"%Y")
      
      ggplot(eParque, aes(date, enel)) + 
        geom_line(color='red', size=0.5) + 
        coord_cartesian(ylim=c(0,max(eParque$enel))) +
        scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
        scale_y_continuous(breaks = seq(0, 5, by = 0.2), expand = c(0.0075,0.0075)) +
        labs(title =paste0("Energía Horaria Generada en el Parque (",fechanios[1],"-",fechanios[2],")"), 
             x = "Fecha", y = "Energía Generada [MWh/dia]") + 
        theme_bw() + theme(text = element_text(size=20))
    })
    output$ePH.plot3 <- renderPlot({
      eParque <- energiaParqueHistorico()$eParque3
      fechanios <- seq(from=eParque$date[100],to=eParque$date[length(eParque$date)], by="year")
      fechanios <- format(fechanios,"%Y")
      
      ggplot(eParque, aes(date, enel)) + 
        geom_line(color='red', size=0.5) + 
        coord_cartesian(ylim=c(0,max(eParque$enel))) +
        scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
        scale_y_continuous(breaks = seq(0, 5, by = 0.2), expand = c(0.0075,0.0075)) +
        labs(title =paste0("Energía Horaria Generada en el Parque (",fechanios[1],"-",fechanios[2],")"), 
             x = "Fecha", y = "Energía Generada [MWh/dia]") + 
        theme_bw() + theme(text = element_text(size=20))
    })
    output$ePH.plot4 <- renderPlot({
      eParque <- energiaParqueHistorico()$eParque4
      fechanios <- seq(from=eParque$date[100],to=eParque$date[length(eParque$date)], by="year")
      fechanios <- format(fechanios,"%Y")
      
      ggplot(eParque, aes(date, enel)) + 
        geom_line(color='red', size=0.5) + 
        coord_cartesian(ylim=c(0,max(eParque$enel))) +
        scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
        scale_y_continuous(breaks = seq(0, 5, by = 0.2), expand = c(0.0075,0.0075)) +
        labs(title =paste0("Energía Horaria Generada en el Parque (",fechanios[1],"-",fechanios[2],")"), 
             x = "Fecha", y = "Energía Generada [MWh/dia]") + 
        theme_bw() + theme(text = element_text(size=20))
    })
    output$ePH.plot5 <- renderPlot({
      eParque <- energiaParqueHistorico()$eParque5
      fechanios <- seq(from=eParque$date[100],to=eParque$date[length(eParque$date)], by="year")
      fechanios <- format(fechanios,"%Y")
      
      ggplot(eParque, aes(date, enel)) + 
        geom_line(color='red', size=0.5) + 
        coord_cartesian(ylim=c(0,max(eParque$enel))) +
        scale_x_datetime(labels = date_format("%Y"), breaks = date_breaks("years")) +
        scale_y_continuous(breaks = seq(0, 5, by = 0.2), expand = c(0.0075,0.0075)) +
        labs(title =paste0("Energía Horaria Generada en el Parque (",fechanios[1],"-",fechanios[2],")"), 
             x = "Fecha", y = "Energía Generada [MWh/dia]") + 
        theme_bw() + theme(text = element_text(size=20))
    })
    
    output$excendencia <- renderPlot({
      E_hor <- Energia_Horaria_Turbina()
      E_hor[[1]] <- NULL
      parque <- parqueEolico()
      #Se genera una sola serie temporal de energía generada como la suma de todas las turbinas con las fechas correspondientes
      ##Se inicializa con la información de la primera turbina
      assign("Energia_Generada_Horaria", E_hor[,1])
      Eparque_hor <- data.frame(cbind(Energia_Generada_Horaria))
      for (i in 2:length(parque[[1]])){
        Eparque_hor <- Eparque_hor+E_hor[,i]
      }
      E_Parque_Hor <- Eparque_hor[[1]]
      E_Parque_Hor <- sort(E_Parque_Hor, decreasing=TRUE)
      F_graf <- seq(from=1/length(E_Parque_Hor),to=length(E_Parque_Hor)/length(E_Parque_Hor), 
                    by=1/length(E_Parque_Hor))
      exceed <- data.frame(F_g=F_graf,E_g=E_Parque_Hor)
      
      ggplot(exceed, aes(F_g*length(E_Parque_Hor), E_g)) +
        geom_line(color='blue', size=1) +
        coord_cartesian(ylim=c(0,max(E_Parque_Hor)),xlim=c(0,90000)) +
        scale_x_continuous(breaks = seq(0, 90000, by = 15000), expand = c(0.0075,0.0075)) +
        scale_y_continuous(breaks = seq(0, 1000, by = 20), expand = c(0.0075,0.0075)) +
        labs(title = "Excedencia de Producción de Energía Horaria del Parque",
             x = "Duración [Horas]", y = "Generación [MWh]") +
        theme_bw() + theme(text = element_text(size=20)) + theme(plot.margin=unit(c(0.5,1,0.25,0.25),"cm"))
    })
    
    output$CEN <- renderText({
      E_hor <- Energia_Horaria_Turbina()
      E_hor[[1]] <- NULL
      parque <- parqueEolico()
      #Se genera una sola serie temporal de energía generada como la suma de todas las turbinas con las fechas correspondientes
      ##Se inicializa con la información de la primera turbina
      assign("Energia_Generada_Horaria", E_hor[,1])
      Eparque_hor <- data.frame(cbind(Energia_Generada_Horaria))
      for (i in 2:length(parque[[1]])){
        Eparque_hor <- Eparque_hor+E_hor[,i]
      }
      E_Parque_Hor <- Eparque_hor[[1]]
      E_Parque_Hor <- sort(E_Parque_Hor, decreasing=TRUE)
      return(quantile(E_Parque_Hor,99.99/100)[[1]])
    })
    
    output$energiaMensual.plot <- renderPlot({
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      if (!is.null(input$Vel_TURBINAS)) {
        vel_estelas <- VelEstelasSubido()
      } else {
        vel_estelas <- Vel_estelas()
      }
      NRG <- Energia_PARQUE()
      
      Vel_Libre <- vel_estelas[[2]]
      VelMesL <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Libre)
      mesesL <- VelMesL %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      mesesL2 <- as.numeric(unlist(mesesL[2]))
      
      vel_estelas[[1]] <- NULL
      vel_estelas[[1]] <- NULL
      Vel_Afectada <- rowMeans(vel_estelas, na.rm=TRUE)
      VelMesA <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Afectada)
      mesesA <- VelMesA %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      mesesA2 <- as.numeric(unlist(mesesA[2]))
      
      energia <- data.frame(velafectada=mesesA2, velibre=mesesL2, enel_mensual=NRG)
      ggplot(energia, aes(color=Velocidades)) +
        geom_point(aes(x=velafectada,y=enel_mensual, color="Velocidad Afectada"), size=2) +
        geom_point(aes(x=velibre,y=enel_mensual, color="Velocidad Libre"), size=2) + 
        coord_cartesian(xlim=c(0,max(mesesL2)), ylim=c(0,max(NRG))) +
        scale_x_continuous(breaks = seq(0, 30, by = 2), expand = c(0.0075,0.0075)) + 
        scale_y_continuous(breaks = seq(0, 10000, by = 100), expand = c(0.0075,0.0075)) +
        scale_color_manual(values=c("red","blue")) +
        labs(title ="Energía Generada Mensual", x = "Velocidad Promedio Mensual [m/s]", y = "Energía Generada Mensual [MWh/dia]") +
        theme_bw() + theme(text = element_text(size=20)) +
        theme(legend.justification = c(1, 1), legend.position = c(0.99, 0.175)) +  
        theme(legend.background = element_rect(colour = 'black', fill = 'white', linetype='solid'))
    })
    
    output$ENFICC <- renderText({
      NRG <- Energia_PARQUE()
      return(round(min(NRG),digits=3))
    })
    
    output$ENFICC_Mes <- renderText({
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      
      NRG <- Energia_PARQUE()
      fechameses <- seq(from=as.POSIXct(fechaRECON[1]),to=as.POSIXct(fechaRECON[length(fechaRECON)]), by="month")
      mesesSpanish <- c("Enero","Febrero","Marzo","Abril","Mayo","Junio",
                        "Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre")
      return(paste0(mesesSpanish[as.numeric(format(fechameses[which.min(NRG)], "%m"))],
                    " de ",format(fechameses[which.min(NRG)], "%Y")))
    })
    
    output$pendienteLibre_Funcion <- renderText({
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      if (!is.null(input$Vel_TURBINAS)) {
        vel_estelas <- VelEstelasSubido()
      } else {
        vel_estelas <- Vel_estelas()
      }
      
      NRG <- Energia_PARQUE()
      Vel_Parque <- vel_estelas[[2]]
      VelMes <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Parque)
      meses <- VelMes %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      meses2 <- as.numeric(unlist(meses[2]))
      funcion_conversion <- lm(NRG ~ meses2)
      coef <- funcion_conversion$coefficients[2]
      return(round(coef,digits=2))
    })
    
    output$pendienteAfectada_Funcion <- renderText({
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      if (!is.null(input$Vel_TURBINAS)) {
        vel_estelas <- VelEstelasSubido()
      } else {
        vel_estelas <- Vel_estelas()
      }
      
      NRG <- Energia_PARQUE()
      vel_estelas[[1]] <- NULL
      vel_estelas[[1]] <- NULL
      Vel_Parque <- rowMeans(vel_estelas, na.rm=TRUE)
      VelMes <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Parque)
      meses <- VelMes %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      meses2 <- as.numeric(unlist(meses[2]))
      funcion_conversion <- lm(NRG ~ meses2)
      coef <- funcion_conversion$coefficients[2]
      return(round(coef,digits=2))
    })
    
    output$interceptoLibre_Funcion <- renderText({
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      if (!is.null(input$Vel_TURBINAS)) {
        vel_estelas <- VelEstelasSubido()
      } else {
        vel_estelas <- Vel_estelas()
      }
      
      NRG <- Energia_PARQUE()
      Vel_Parque <- vel_estelas[[2]]
      VelMes <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Parque)
      meses <- VelMes %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      meses2 <- as.numeric(unlist(meses[2]))
      funcion_conversion <- lm(NRG ~ meses2)
      coef <- funcion_conversion$coefficients[1]
      return(round(coef,digits=2))
    })
    
    output$interceptoAfectada_Funcion <- renderText({
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      if (!is.null(input$Vel_TURBINAS)) {
        vel_estelas <- VelEstelasSubido()
      } else {
        vel_estelas <- Vel_estelas()
      }
      
      NRG <- Energia_PARQUE()
      vel_estelas[[1]] <- NULL
      vel_estelas[[1]] <- NULL
      Vel_Parque <- rowMeans(vel_estelas, na.rm=TRUE)
      VelMes <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Parque)
      meses <- VelMes %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      meses2 <- as.numeric(unlist(meses[2]))
      funcion_conversion <- lm(NRG ~ meses2)
      coef <- funcion_conversion$coefficients[1]
      return(round(coef,digits=2))
    })
  })
  
  output$energiaTurbina <- downloadHandler(
    filename = function(){
      paste0("EnergiaHorariaTurbina-", Sys.Date(), ".csv", sep="")
    },
    content = function(file) {
      NRG_horaria <- Energia_Horaria_Turbina()
      DownLoadData <- NRG_horaria;
      write.csv(x = DownLoadData, file = file)
    }
  )
  
  output$energiaHorariaParque <- downloadHandler(
    filename = function(){
      paste0("CENParqueHorario-", Sys.Date(), ".csv", sep="")
    },
    content = function(file) {
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      E_hor[[1]] <- NULL
      parque <- parqueEolico()
      #Se genera una sola serie temporal de energía generada como la suma de todas las turbinas con las fechas correspondientes
      ##Se inicializa con la información de la primera turbina
      assign("Energia_Generada_Horaria", E_hor[,1])
      Eparque_hor <- data.frame(cbind(Energia_Generada_Horaria))
      for (i in 2:length(parque[[1]])){
        Eparque_hor <- Eparque_hor+E_hor[,i]
      }
      
      TABLA=data.frame(fechaRECON,round(Eparque_hor,digits=3));
      DownLoadData <- TABLA;
      colnames(DownLoadData)[1] <- "Fecha_y_Hora";
      colnames(DownLoadData)[2] <- "Energía_Generada_Horaria(MWh)";
      write.csv(x = DownLoadData, file = file)
    }
  )
  
  output$energiaParque <- downloadHandler(
    filename = function(){
      paste0("EnergiaMensualParque-", Sys.Date(), ".csv", sep="")
    },
    content = function(file) {
      E_hor <- Energia_Horaria_Turbina()
      fechaRECON <- E_hor[,1]
      fechameses <- seq(from=as.POSIXct(fechaRECON[1]),to=as.POSIXct(fechaRECON[length(fechaRECON)]), by="month")
      if (!is.null(input$Vel_TURBINAS)) {
        vel_estelas <- VelEstelasSubido()
      } else {
        vel_estelas <- Vel_estelas()
      }
      NRG <- Energia_PARQUE()
      
      Vel_Libre <- vel_estelas[[2]]
      VelMesL <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Libre)
      mesesL <- VelMesL %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      mesesL2 <- as.numeric(unlist(mesesL[2]))
      
      vel_estelas[[1]] <- NULL
      vel_estelas[[1]] <- NULL
      Vel_Afectada <- rowMeans(vel_estelas, na.rm=TRUE)
      VelMesA <- data_frame(fecha=as.POSIXct(strptime(fechaRECON, "%Y-%m-%d %H:%M:%S", "")),vel=Vel_Afectada)
      mesesA <- VelMesA %>% group_by(month=floor_date(fecha, "month")) %>%
        summarize(vel=mean(vel))
      mesesA2 <- as.numeric(unlist(mesesA[2]))
      
      TABLA=data.frame(fechameses,round(mesesL2,digits=3),round(mesesA2,digits=3),round(NRG,digits=3));
      DownLoadData <- TABLA;
      colnames(DownLoadData)[1] <- "Fecha";
      colnames(DownLoadData)[2] <- "Velocidad_Mensual_Libre(m/s)";
      colnames(DownLoadData)[3] <- "Velocidad_Mensual_Afectada(m/s)";
      colnames(DownLoadData)[4] <- "Energía_Generada_Mensual(MWh/dia)";
      write.csv(x = DownLoadData, file = file)
    }
  )
}
