#Limpieza de parametros y variables previas
rm(list=ls())

datos_secundario <- read.csv(paste(.libPaths()[1], "/ENFICC/data/NRELprueba2.csv", sep = ""))
seriesec <- serie(altura=19, v.prom=datos_secundario[,2], dir.prom=datos_secundario[,3])
fechasec <- mt(marcatemporal = datos_secundario[,1])
torresec <- torre(marcatemporal = fechasec, seriesec)

orig <- ts(torresec$series$serie1$data$v.prom,
           start=c(as.numeric(format(as.Date(fechasec[1]),'%Y')),as.numeric(format(as.Date(fechasec[1]),'%m'))),
           frequency=17520)
VelHor <- as.numeric(aggregate(orig, nfrequency=8760)/2)

orig <- ts(torresec$series$serie1$data$dir.prom,
           start=c(as.numeric(format(as.Date(fechasec[1]),'%Y')),as.numeric(format(as.Date(fechasec[1]),'%m'))),
           frequency=17520)
DirHor <- as.numeric(aggregate(orig, nfrequency=8760)/2)

fecha_horaria <- seq(from=as.POSIXct(fechasec[1]),to=as.POSIXct(fechasec[length(fechasec)]), by="hour")

titulos_sitio=c("Fechas","Velocidad","Direccion")
TABLE_sitio=data.frame(fecha_horaria,VelHor,DirHor)
names(TABLE_sitio)=titulos_sitio
write.csv(x = TABLE_sitio,file = paste(.libPaths()[1], "/ENFICC/fuente_secundaria.csv", sep = ""))
