lonINI <- -71.226
latINI <- 12.287679
lon <- rep(0,100)
lat <- rep(latINI,100)
index <- c(1:100)
lon[1] <- lonINI
for (i in 2:100) {
  lon[i] <- lon[i-1] - 0.002
}
parqueEolico <- data.frame(Indice_Turbina=index,Longitud=lon,Latitud=lat,Altitud=rep(0,100))

NT <- length(parqueEolico[[1]])
#Se refieren las posiciones de las turbinas con la primera de la lista para generar ubicaciones en metros
parqueEnMetros <- parqueEolico
x_m <- rep(0,NT)
y_m <- rep(0,NT)
parqueEnMetros <- cbind(parqueEnMetros, x_m, y_m)
for(i in 2:NT){
  longT1 <- parqueEnMetros[[2]][1]
  longT2 <- parqueEnMetros[[2]][i]
  latT1 <- parqueEnMetros[[3]][1]
  latT2 <- parqueEnMetros[[3]][i]
  sign_x <- sign(longT2 - longT1)
  sign_y <- sign(latT2 - latT1)
  ##El método distVincentyEllipsoid calcula la distancia basado en el elipsoide WGS84 como modelo del planeta Tierra
  vecturb <- c((sign_x*distVincentyEllipsoid(c(longT2,latT1),c(longT1,latT1))),
               (sign_y*distVincentyEllipsoid(c(longT1,latT2),c(longT1,latT1))))
  parqueEnMetros[[5]][i] <- vecturb[1]
  parqueEnMetros[[6]][i] <- vecturb[2]
}

numTorres <- 1
serie_dir <- rep(0,numTorres)
for (j in 1:numTorres) {
  serie_dir[j] <- 90
}
theta_prom <- mean(serie_dir)
a <- sin(theta_prom*pi/180)
b <- cos(theta_prom*pi/180)
assign("IndiceT", parqueEnMetros[[1]])
TurbReorg <- data.frame(cbind(IndiceT))
TurbReorg["Reubicacion"] <- a*parqueEnMetros[[5]] + b*parqueEnMetros[[6]]
TurbReorg <- TurbReorg[with(TurbReorg,order(-Reubicacion)),]
parqueReorg <- parqueEnMetros
borrar <- c("Longitud","Latitud")
parqueReorg <- parqueReorg[ , !(names(parqueReorg) %in% borrar)]
for (j in 1:NT){
  if(!parqueEolico[[1]][j]==TurbReorg$IndiceT[j]) {
    parqueReorg[[1]][j] <- parqueEnMetros[[1]][TurbReorg$IndiceT[j]]
    parqueReorg[[2]][j] <- parqueEnMetros[[4]][TurbReorg$IndiceT[j]]
    parqueReorg[[3]][j] <- parqueEnMetros[[5]][TurbReorg$IndiceT[j]]
    parqueReorg[[4]][j] <- parqueEnMetros[[6]][TurbReorg$IndiceT[j]]
    parqueReorg[[5]][j] <- parqueEnMetros[[7]][TurbReorg$IndiceT[j]]
  }
}

dir <- (90-serie_dir)*(pi/180)
#Direcciones de cada turbina
dirturb <- rep(0,NT)
for(j in 1:NT) {
  dirturb[j] <- dir
}

voo <- rep(0,NT)
for(j in 1:NT) {
  voo[j] <- 10
}
diametro <- 92
altCubo <- 92
radtur <- diametro/2

#Rugosidad del terreno
z_01 <- 0.055
# #Rugosidad del parque usando openwind
# sd <- 137*4/diametro
# sc <- 1370/diametro
# C_T <- 0.71
# c_t <- pi*C_T/(8*sd*sc)
# z_00 <- altCubo*exp(-0.42/sqrt(c_t+((0.42/log(altCubo/z_01))^2)))
# #Rugosidad Aumentada
# z_02 <- z_01 + z_00
#Rugosidad Aumentada
z_02 <- z_01 + 0.03

for(i in 2:NT) {
  #Vector unitario de dirección del viento
  vecdir <- c(-cos(dirturb[i]),-sin(dirturb[i]),0)
  #Cálculo del vector entre las turbinas T1 Y T2
  vecturb <- c(parqueReorg[[3]][i]-parqueReorg[[3]][1],parqueReorg[[4]][i]-parqueReorg[[4]][1],
               (parqueReorg[[2]][i]+altCubo)-(parqueReorg[[2]][1]+altCubo))
  #Cálculo de la proyección (producto punto) del vector entre las turbinas objetivo y la que está más a barlovento
  #sobre el vector de dirección del viento
  x_dist <- vecturb%*%vecdir
  if (x_dist>0) {
    #Se despeja la altura de la capa límite interna
    ecuacion <- function(h,x,z_02) (h*(log(h/z_02)-1)-0.9*x)
    h_IBL <- (2*altCubo/3)+uniroot(f=ecuacion,interval=c(0.0001,10000),x=x_dist,z_02=z_02)$root
    z_new <- altCubo - radtur
    if (x_dist/diametro<60) {
      if (0.09*h_IBL<z_new && z_new<0.3*h_IBL) {
        voo[i] <- (voo[i]/log(z_new/z_01))*
          ((log(h_IBL/z_01)/log(h_IBL/z_02))*log(0.09*h_IBL/z_02)*(1-(log(z_new/(0.09*h_IBL))/log(0.3/0.09)))+
                                              log(0.3*h_IBL/z_01)*(log(z_new/(0.09*h_IBL))/log(0.3/0.09)))
      } else if (z_new<0.09*h_IBL) {
        voo[i] <- voo[i]*(log(h_IBL/z_01)*log(z_new/z_02))/(log(z_new/z_01)*log(h_IBL/z_02))
      } else voo[i] <- voo[i]
    } else {
      x_start <- 60*diametro
      x_50 <- 40*diametro
      h_IBL_start <- (2*altCubo/3)+uniroot(f=ecuacion,interval=c(0.0001,10000),x=x_start,z_02=z_02)$root
      if (0.09*h_IBL_start<z_new && z_new<0.3*h_IBL_start) {
        u1 <- (voo[i]/log(z_new/z_01))*
          ((log(h_IBL_start/z_01)/log(h_IBL_start/z_02))*log(0.09*h_IBL_start/z_02)*(1-(log(z_new/(0.09*h_IBL_start))/log(0.3/0.09)))+
             log(0.3*h_IBL_start/z_01)*(log(z_new/(0.09*h_IBL_start))/log(0.3/0.09)))
      } else {
        u1 <- voo[i]*(log(h_IBL_start/z_01)*log(z_new/z_02))/(log(z_new/z_01)*log(h_IBL_start/z_02))
      }
      if (0.09*h_IBL<z_new && z_new<0.3*h_IBL) {
        u <- (voo[i]/log(z_new/z_01))*
          ((log(h_IBL/z_01)/log(h_IBL/z_02))*log(0.09*h_IBL/z_02)*(1-(log(z_new/(0.09*h_IBL))/log(0.3/0.09)))+
             log(0.3*h_IBL/z_01)*(log(z_new/(0.09*h_IBL))/log(0.3/0.09)))
      } else {
        u <- voo[i]*(log(h_IBL/z_01)*log(z_new/z_02))/(log(z_new/z_01)*log(h_IBL/z_02))
      }
      voo[i] <- voo[i]*(1-(1-(u/voo[i]))*0.5^((x_dist-x_start)/x_50))
    }
  }
}
  