---
output: html_document
---

<style type="text/css">
body{ /* Normal  */
      font-size: 15px;
  }
</style>

<img src="logo_aplicativo.png" alt="Logo" style="width: 96%"/> </br>
***
***
Bienvenido a **ENFICC - Energía Eólica**: un aplicativo web para el cálculo de la energía en firme por cargo de confiabilidad para plantas eólicas. Contiene herramientas para la visualización de datos de variables meteorológicas, extrapolación temporal y por altura de series de velocidad de viento.

De acuerdo con lo previsto en la Resolución CREG 167 de 2017, el CNO expidió el Acuerdo 1094, por el cual se aprueban los protocolos asociados al cálculo de la ENFICC de las plantas eólicas” y desarrolló un modelo en código “R” para facilitar su aplicación. Los sustentos teóricos para las herramientas de cálculo de este aplicativo se pueden consultar en los Anexos del Acuerdo: 

[Protocolos correspondientes a la Resolución 167 de 2017 - Acuerdo 1094 del CNO](https://www.cno.org.co/sites/default/files/archivosAdjuntos/anexo_1_acuerdo_1094_1.pdf)

## <a name="actualizacion1"></a> Actualización 1.0

Algunas nuevas instrucciones de R deben ser tenidas en cuenta para la correcta ejecución del aplicativo:

*Versión de R instalada:*

La versión de R instalada debe ser por lo menos la versión 3.5.1 "Feather Spray", la cual es la más reciente para la fecha de esta actualización. Esto es esencial para que los paquetes actualizados funcionen correctamente.

*Actualización e instalación de paquetes en R:*

Es necesario seguir el siguiente procedimiento de instalación de paquetes para poder utilizar todas las herramientas del aplicativo correctamente. En primer lugar, instale los siguientes paquetes insertando la siguiente línea en el espacio destinado para ello en la pestaña "Install":

```{r echo=T}
dplyr doParallel DT geosphere ggimage ggplot2 gridExtra lubridate openair png RColorBrewer readbitmap RgoogleMaps scales shiny shinyjs shinythemes tidyverse zoo devtools
```

Si ya tiene alguno de estos paquetes instalados, RStudio se encargará de actualizarlos en caso de que el usuario tenga una versión anterior a la actual.

*Correcta instalación del paquete "ggmap":*

Debido a una actualización de políticas de de Google Maps, es necesario realizar unos ajustes al paquete "ggmap" instalado en su RStudio:
- En primer lugar, desinstale el paquete que tenga actualmente si ya lo tenía instalado en un ocasión anterior.
- Ahora, instále "ggmap" ejecutando la siguiente línea en la consola:

```{r echo=T}
devtools::install_github("dkahle/ggmap", ref = "tidyup")
```

Asegúrese de que se instalen correctamente los subpaquetes y el paquete "ggmap":
<img src="verificacion1.png" style="width: 65%"/> </br>
<img src="verificacion2.png" style="width: 25%"/> </br>

*Recomendaciones Finales:*

*- Ubicación de la carpeta:*

Descomprima el paquete en una carpeta cuyo directorio no sea largo, pues esto le genera problemas al aplicativo al momento de ubicar sus archivos internos. Se sugieren ubicaciones como "Documentos", "Escritorio" o una carpeta ubicada en la raíz de una unidad (por ejemplo, C:, D:, E:)

*- Visualización de los Mapas:*

Aunque el nivel de acercamiento (zoom) predeterminado en el aplicativo ha probado ser efectivo al momento de realizar de mapas, es posible que en algunos casos, el zoom sea bastante alto en esa zona como para que Google Maps muestre un mapa, en este caso se presenta un error de este estilo:
<img src="mapamal.png" style="width: 50%"/> </br>

En este caso haga clic en el botón de abajo "Alejar Vista del Mapa", el cual alejará el zoom a un punto que Google Maps pueda visualizar:
<img src="mapabien.png" style="width: 50%"/> </br>


## <a name="funcionamiento"></a> ¿Cómo Funciona el Aplicativo?

*Visualice sus datos de entrada:*

- Observe la ubicación de sus turbinas, trazado eléctrico y torres meteorológicas en un mapa satelital.
<img src="parque_trazado.png" style="width: 95%"/> </br>

- RECUERDE: Los archivos de entrada deben estar en formato .csv *comma-separated-value*, los cuales puede exportar desde Microsoft Excel.

- En el siguiente video-tutorial se puede observar la amplia variedad de herramientas de visualización que posee el aplicativo. Haga clic en la siguiente imagen:

<a href="http://www.youtube.com/watch?feature=player_embedded&v=DjHYi1BWqQg
" target="_blank"><img src="http://img.youtube.com/vi/DjHYi1BWqQg/0.jpg" 
alt="ENFICC - Herramientas de Visualización" width="720" height="540" border="10" /></a>

*Ejecute los pasos de cálculo para la estimación del ENFICC:*

Haga clic en la siguiente imagen para observar el video-tutorial:
<a href="http://www.youtube.com/watch?feature=player_embedded&v=pTJZqoInEiE
" target="_blank"><img src="http://img.youtube.com/vi/pTJZqoInEiE/0.jpg" 
alt="Pasos de Cálculo del ENFICC" width="720" height="540" border="10" /></a>

## <a name="parqueprueba"></a> Ejecución del Parque de Prueba
Para ejecutar el cálculo de ENFICC del parque de prueba, siga las instrucciones del siguiente video-tutorial haciendo clic en la siguiente imagen:
<a href="http://www.youtube.com/watch?feature=player_embedded&v=HHEBtg8cUcE
" target="_blank"><img src="http://img.youtube.com/vi/HHEBtg8cUcE/0.jpg" 
alt="Cálculo del ENFICC en el Parque de Prueba" width="720" height="540" border="10" /></a>
